; hellowin.pb
; based on hellowin.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "hellowin", main_caption.s = "The Hello Program"
Global hinstance = GetModuleHandle_(#NULL)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Main Window Message Handlers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Procedure main_callback(hwin, message, wparam, lparam)
    Static client_area_text.s = "Hello, Windows!"
    Static hello_file_name.s = "hellowin.wav"

    Select message
        Case #WM_PAINT
            Define ps.PAINTSTRUCT, rc.RECT
            Define hdc = BeginPaint_(hwin, ps)

            GetClientRect_(hwin, rc)
            DrawText_(hdc, @client_area_text, -1, rc, #DT_SINGLELINE | #DT_CENTER | #DT_VCENTER)

            EndPaint_(hwin, ps)
        Case #WM_CREATE
            PlaySound_(hello_file_name, 0, #SND_FILENAME | #SND_ASYNC)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect
    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    Define main_class.WNDCLASS
            With main_class
                \lpfnWndProc = @main_callback()
                \hinstance = hinstance
                \lpszClassName = @app_name
                \style = #CS_HREDRAW | #CS_VREDRAW
                \hicon = LoadIcon_(0, #IDI_APPLICATION)
                \hcursor = LoadCursor_(0, #IDC_ARROW)
                \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf
            ShowWindow_(hwin, #SW_SHOW)
            UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
