; sysmets1.pb
; based on sysmets1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "sysmets.pbi"

Global app_name.s = "sysmets1", main_caption.s = "Get System Metrics No. 1"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static char_width, caps_width, char_height
    Define hdc, i, tm.TEXTMETRIC

    Select message
        Case #WM_CREATE 
            hdc = GetDC_(hwin)

            GetTextMetrics_(hdc, tm)
            char_width = tm\tmAveCharWidth
            If tm\tmPitchAndFamily & 1 
                caps_width = 3 * char_width/2
            Else
                caps_width = char_width
            EndIf
            char_height = tm\tmHeight + tm\tmExternalLeading

            ReleaseDC_(hwin, hdc)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)

            For i = 0 To (#NUMLINES-1)
                text_out(hdc, 0, char_height * i, sys_metrics(i)\name)
                text_out(hdc, 22 * caps_width, char_height * i, sys_metrics(i)\desc)

                SetTextAlign_(hdc, #TA_RIGHT | #TA_TOP)

                text_out(hdc, 22 * caps_width + 40 * char_width, char_height * i, RSet(StrU(GetSystemMetrics_(sys_metrics(i)\flag),#PB_Long), 5))
    
                SetTextAlign_(hdc, #TA_LEFT | #TA_TOP)
            Next i
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

     ProcedureReturn 0
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
            With main_class
                \lpfnWndProc = @main_callback()
                \hinstance = hinstance
                \lpszClassName = @app_name
                \style = #CS_HREDRAW | #CS_VREDRAW
                \hicon = LoadIcon_(0, #IDI_APPLICATION)
                \hcursor = LoadCursor_(0, #IDC_ARROW)
                \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf


    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

            ShowWindow_(hwin, #SW_SHOW)
            UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam