; sysmets2.pb
; based on sysmets2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "sysmets.pbi"

Global app_name.s = "sysmets2", main_caption.s = "Get System Metrics No. 2"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static char_width, caps_width, char_height, client_height, scroll_vert_pos
    Define hdc, i, tm.TEXTMETRIC, y

    Select message
        Case #WM_CREATE 
            hdc = GetDC_(hwin)

            GetTextMetrics_(hdc, tm)
            char_width = tm\tmAveCharWidth
            If tm\tmPitchAndFamily & 1 
                caps_width = 3 * char_width/2
            Else
                caps_width = char_width
            EndIf
            char_height = tm\tmHeight + tm\tmExternalLeading

            ReleaseDC_(hwin, hdc)

            SetScrollRange_(hwin, #SB_VERT, 0, #NUMLINES - 1, #False)
            SetScrollPos_(hwin, #SB_VERT, scroll_vert_pos, #True)
        Case #WM_SIZE
            client_height = HIWORD(lparam)
        Case #WM_VSCROLL
            Select LOWORD(wparam)
                Case #SB_LINEUP
                    scroll_vert_pos = scroll_vert_pos - 1
                Case #SB_LINEDOWN
                    scroll_vert_pos = scroll_vert_pos + 1
                Case #SB_PAGEUP
                    scroll_vert_pos = scroll_vert_pos - client_height / char_height
                Case #SB_PAGEDOWN
                    scroll_vert_pos = scroll_vert_pos + client_height / char_height
                Case #SB_THUMBPOSITION
                    scroll_vert_pos = HIWORD(wparam)
            EndSelect
            scroll_vert_pos = max(0, min(scroll_vert_pos, #NUMLINES - 1))

            If scroll_vert_pos <> GetScrollPos_(hwin, #SB_VERT)
                SetScrollPos_(hwin, #SB_VERT, scroll_vert_pos, #True)
                InvalidateRect_(hwin, #Null, #True)
            EndIF
        Case #WM_PAINT
            define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)

            For i = 0 to (#NUMLINES-1)
                y = char_height * (i - scroll_vert_pos)

            
                text_out(hdc, 0, y, sys_metrics(i)\name)
                text_out(hdc, 22 * caps_width, y, sys_metrics(i)\desc)

                SetTextAlign_(hdc, #TA_RIGHT | #TA_TOP)

                text_out(hdc, 22 * caps_width + 40 * char_width, y, RSet(StrU(GetSystemMetrics_(sys_metrics(i)\flag),#PB_Long), 5))
    
                SetTextAlign_(hdc, #TA_LEFT | #TA_TOP)
            Next i
          
            EndPaint_(hwin, ps)
            ProcedureReturn 0
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 
    ProcedureReturn 0
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_VSCROLL,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf 
        
        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam    
