; sinewave.pb
; based on sinewave.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "sinewave", main_caption.s = "Sine Wave Using Polyline"
Global hinstance = GetModuleHandle_(#NULL)

#NUM  = 1000
#TWOPI = (2 * 3.14159)

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_PAINT
            Dim apt.POINT(#NUM-1)
            Define ps.PAINTSTRUCT
            Define hdc = BeginPaint_(hwin, ps)
            
            line_to(hdc, 0, client_height / 2,  client_width, client_height / 2)
    
            Define i
            For i = 0 to (#NUM-1)
                apt(i)\x = int(i * client_width / #NUM)
                apt(i)\y = int((client_height / 2 *(1 - sin(#TWOPI * i / #NUM))))
            Next i
    
            Polyline_(hdc, apt(), #NUM)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam