; bezier.pb
; based on bezier.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "bezier", main_caption.s = "Bezier Splines"
Global hinstance = GetModuleHandle_(#NULL)

IncludePath ""
XIncludeFile "bezier.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static DIM apt.POINT(3)
    define hdc, client_width, client_height
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)

            apt(0)\x = client_width / 4
            apt(0)\y = client_height / 2
            
            apt(1)\x = client_width / 2
            apt(1)\y = client_height / 4
            
            apt(2)\x =    client_width / 2
            apt(2)\y = 3 * client_height / 4
            
            apt(3)\x = 3 * client_width / 4
            apt(3)\y =    client_height / 2
        Case #WM_LBUTTONDOWN, #WM_RBUTTONDOWN, #WM_MOUSEMOVE
            If (wparam & #MK_LBUTTON) or (wparam & #MK_RBUTTON)
                hdc = GetDC_(hwin)

                SelectObject_(hdc, GetStockObject_(#WHITE_PEN))
                draw_bezier(hdc, apt())
                
                If (wparam & #MK_LBUTTON)
                    apt(1)\x = LOWORD(lparam)
                    apt(1)\y = HIWORD(lparam)
                EndIf
                
                if (wparam & #MK_RBUTTON)
                    apt(2)\x = LOWORD(lparam)
                    apt(2)\y = HIWORD(lparam)
                EndIf
                
                SelectObject_(hdc, GetStockObject_(#BLACK_PEN))
                draw_bezier(hdc, apt())
                ReleaseDC_(hwin, hdc)
            EndIf
        Case #WM_PAINT
            InvalidateRect_(hwin, #NULL, #True)
        
            define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            draw_bezier(hdc, apt())
      
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam