; altwind.pb
; based on altwind.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "altwind", main_caption.s = "Alternate and Winding Fill Modes"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Static Dim apt_figure.POINT(9)  
    define hdc, i
    Dim apt.POINT(9)
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE
            apt_figure(0)\x = 10   : apt_figure(0)\y = 70 
            apt_figure(1)\x = 50   : apt_figure(1)\y = 70 
            apt_figure(2)\x = 50   : apt_figure(2)\y = 10 
            apt_figure(3)\x = 90   : apt_figure(3)\y = 10 
            apt_figure(4)\x = 90   : apt_figure(4)\y = 50 
            apt_figure(5)\x = 30   : apt_figure(5)\y = 50 
            apt_figure(6)\x = 30   : apt_figure(6)\y = 90 
            apt_figure(7)\x = 70   : apt_figure(7)\y = 90 
            apt_figure(8)\x = 70   : apt_figure(8)\y = 30 
            apt_figure(9)\x = 10   : apt_figure(9)\y = 30 
            
        Case #WM_PAINT
            define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, GetStockObject_(#GRAY_BRUSH))
    
            for i = 0 to 9
                apt(i)\x = client_width * apt_figure(i)\x / 200 
                apt(i)\y = client_height * apt_figure(i)\y / 100 
            Next i
    
            SetPolyFillMode_(hdc, #ALTERNATE)
            Polygon_(hdc, apt(), 10)
    
            for i = 0 to 9
                apt(i)\x = apt(i)\x + client_width / 2
            Next i
    
            SetPolyFillMode_(hdc, #WINDING)
            Polygon_(hdc, apt(), 10)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam