; whatsize.pb
; based on whatsize.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "whatsize", main_caption.s = "What Size is the Window?"
Global hinstance = GetModuleHandle_(#NULL)

IncludePath ""
XIncludeFile "whatsize.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static char_width, char_height, client_width, client_height, heading.s, underline.s
    Define hdc
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE 
            Define tm.TEXTMETRIC
            heading = "Mapping Mode            Left   Right     Top  Bottom"
            underline = "------------            ----   -----     ---  ------"

            hdc = GetDC_(hwin)
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            
            GetTextMetrics_(hdc, tm)
            char_width = tm\tmAveCharWidth
            char_height = tm\tmHeight + tm\tmExternalLeading
            
            ReleaseDC_(hwin, hdc)

        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            
            SetMapMode_(hdc, #MM_ANISOTROPIC)
            SetWindowExtEx_(hdc, 1, 1, #NULL)
            SetViewportExtEx_(hdc, char_width, char_height, #NULL)
            
            text_out(hdc, 1, 1, heading)
            text_out(hdc, 1, 2, underline)
            
            show(hwin, hdc, 1, 3, #MM_TEXT, "TEXT (pixels)")
            show(hwin, hdc, 1, 4, #MM_LOMETRIC, "LOMETRIC (.1 mm)")
            show(hwin, hdc, 1, 5, #MM_HIMETRIC, "HIMETRIC (.01 mm)")
            show(hwin, hdc, 1, 6, #MM_LOENGLISH, "LOENGLISH (.01 in)")
            show(hwin, hdc, 1, 7, #MM_HIENGLISH, "HIENGLISH (.001 in)")
            show(hwin, hdc, 1, 8, #MM_TWIPS, "TWIPS (1/1440 in)")
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam