; clover.pb
; based on clover.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "clover", main_caption.s = "Draw a Clover"
Global hinstance = GetModuleHandle_(#NULL)

#TWO_PI = (2.0 * 3.14159)
#STEPSIZE = #TWO_PI / 360

Procedure.d hypot(a.d, b.d)
    ProcedureReturn pow(a*a + b*b, 0.5) 
EndProcedure

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, hrgn_clip
    Define hdc, angle.d, radius.d, hcursor, i
    Dim hrgn_temp(5)
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)

            hcursor = SetCursor_(LoadCursor_(#NULL, #IDC_WAIT))
            ShowCursor_(#True)
            
            If hrgn_clip
                DeleteObject_(hrgn_clip)
            EndIf
            
            hrgn_temp(0) = CreateEllipticRgn_(0, client_height / 3, client_width / 2, 2 * client_height / 3)
            hrgn_temp(1) = CreateEllipticRgn_(client_width / 2, client_height / 3, client_width, 2 * client_height / 3)
            hrgn_temp(2) = CreateEllipticRgn_(client_width / 3, 0, 2 * client_width / 3, client_height / 2)
            hrgn_temp(3) = CreateEllipticRgn_(client_width / 3, client_height / 2, 2 * client_width / 3, client_height)
            hrgn_temp(4) = CreateRectRgn_(0, 0, 1, 1)
            hrgn_temp(5) = CreateRectRgn_(0, 0, 1, 1)
            hrgn_clip    = CreateRectRgn_(0, 0, 1, 1)
            
            CombineRgn_(hrgn_temp(4), hrgn_temp(0), hrgn_temp(1), #RGN_OR)
            CombineRgn_(hrgn_temp(5), hrgn_temp(2), hrgn_temp(3), #RGN_OR)
            CombineRgn_(hrgn_clip,    hrgn_temp(4), hrgn_temp(5), #RGN_XOR)
            
            For i = 0 to 5
                DeleteObject_(hrgn_temp(i))
            Next i
            SetCursor_(hcursor)
            ShowCursor_(#False)

        Case #WM_PAINT
            define ps.PAINTSTRUCT

            hdc = BeginPaint_(hwin, ps)

            SetViewportOrgEx_(hdc, client_width / 2, client_height / 2, #NULL)
            SelectClipRgn_(hdc, hrgn_clip)
            
            radius = hypot(client_width / 2.0, client_height / 2.0)
            
           
            For i = 0 to 359
            ;For angle = 0.0 to TWO_PI Step TWO_PI / 360
                angle = i * #STEPSIZE
                line_to(hdc, 0,0, Int(radius * cos(angle) + 0.5), Int(-radius * sin(angle) + 0.5))
            Next i
       
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            DeleteObject_(hrgn_clip)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam