; stokfont.pb
; based on stokfont.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "stokfont", main_caption.s = "Stock Fonts"
Global hinstance = GetModuleHandle_(#NULL)

Structure STOCKFONT
    id_stock_font.l
    stock_font_label.s
EndStructure

#STOCKFONTCOUNT = 7
Global Dim stock_font.STOCKFONT(#STOCKFONTCOUNT-1)
stock_font(0)\id_stock_font = #OEM_FIXED_FONT: stock_font(0)\stock_font_label = "OEM_FIXED_FONT"
stock_font(1)\id_stock_font = #ANSI_FIXED_FONT: stock_font(1)\stock_font_label = "ANSI_FIXED_FONT"
stock_font(2)\id_stock_font = #ANSI_VAR_FONT: stock_font(2)\stock_font_label = "ANSI_VAR_FONT"
stock_font(3)\id_stock_font = #SYSTEM_FONT: stock_font(3)\stock_font_label = "SYSTEM_FONT"
stock_font(4)\id_stock_font = #DEVICE_DEFAULT_FONT: stock_font(4)\stock_font_label = "DEVICE_DEFAULT_FONT"
stock_font(5)\id_stock_font = #SYSTEM_FIXED_FONT: stock_font(5)\stock_font_label = "SYSTEM_FIXED_FONT"
stock_font(6)\id_stock_font = #DEFAULT_GUI_FONT: stock_font(6)\stock_font_label = "DEFAULT_GUI_FONT"
 
Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Static i_font, c_fonts = #STOCKFONTCOUNT
    Define hdc, i, x, y, cell_width, cell_height
    Dim chb_face_name.c(#LF_FACESIZE-1)
    Define tm.TEXTMETRIC, s_buffer.s
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_DISPLAYCHANGE
            InvalidateRect_(hwin, #NULL, #True)
        Case #WM_VSCROLL
            Select LOWORD(wparam)
                Case #SB_TOP
                    i_font = 0
                Case #SB_BOTTOM
                    i_font = c_fonts - 1
                Case #SB_LINEUP, #SB_PAGEUP
                    i_font - 1
                Case #SB_LINEDOWN, #SB_PAGEDOWN
                    i_font + 1
                Case #SB_THUMBPOSITION
                    i_font = HIWORD(wparam)
            EndSelect
            i_font = max(0, min(c_fonts - 1, i_font))
            SetScrollPos_(hwin, #SB_VERT, i_font, #True)
            InvalidateRect_(hwin, #NULL, #True)
        case #WM_KEYDOWN
            Select wparam
                Case #VK_HOME
                    SendMessage_(hwin, #WM_VSCROLL, #SB_TOP, 0)
                Case #VK_END
                    SendMessage_(hwin, #WM_VSCROLL, #SB_BOTTOM, 0)
                Case #VK_PRIOR, #VK_LEFT, #VK_UP
                    SendMessage_(hwin, #WM_VSCROLL, #SB_LINEUP, 0)
                Case #VK_NEXT, #VK_RIGHT, #VK_DOWN
                    SendMessage_(hwin, #WM_VSCROLL, #SB_PAGEDOWN, 0)
            EndSelect
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, GetStockObject_(stock_font(i_font)\id_stock_font))
            GetTextFace_(hdc, #LF_FACESIZE, chb_face_name())
            GetTextMetrics_(hdc, tm)
            cell_width = max(3 * tm\tmAveCharWidth, 2 * tm\tmMaxCharWidth)
            cell_height = tm\tmHeight + 3
    
            s_buffer = " " + stock_font(i_font)\stock_font_label + ": Face Name = " + PeekS(chb_face_name(), #LF_FACESIZE) + ", CharSet = " + StrU(tm\tmCharSet, #PB_Byte)
            text_out(hdc, 0, 0, s_buffer) 
    
            SetTextAlign_(hdc, #TA_TOP | #TA_CENTER)
    
            ; vertical and horizontal lines
            For i = 0 to 16 
                line_to(hdc, (i + 2) * cell_width,      2 * cell_height,   (i + 2) * cell_width,      19 * cell_height)
                line_to(hdc,           cell_width,(i + 3) * cell_height,        18 * cell_width, (i + 3) * cell_height)
            Next i

            ; vertical and horizontal headings
            For i = 0 to 15 
                s_buffer = Hex(i) + "-"
                text_out(hdc, (2 * i + 5) * cell_width / 2, 2 * cell_height + 2, s_buffer)
    
                s_buffer = "-" + Hex(i)
                text_out(hdc, 3 * cell_width / 2,(i + 3) * cell_height + 2, s_buffer)
            Next i
 
            ; characters
            For y = 0 to 15
                For x = 0 to 15
                    ; Use full TextOut_() api call here, so the length parameter here
                    ; will force display  of the #NULL when at grid pos 0,0.
                    ; Also, using a string var doesn't work for some of the
                    ; higher characters (don't know why), so I use a .c var.
                    Define ch.c = 16*x+y
                    TextOut_(hdc,(2 * x + 5) * cell_width / 2, (y + 3) * cell_height + 2, @ch, 1)
                Next x
            Next y
            EndPaint_(hwin, ps)
        Case #WM_CREATE 
            ; set the scroll range so that the font index can serve as a scroll bar positioner
            SetScrollRange_(hwin, #SB_VERT, 0, c_fonts - 1, #True)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam