; keyview2.pb
; based on keyview2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "keyview2", main_caption.s = "Keyboard Message Viewer #2"
Global hinstance = GetModuleHandle_(#NULL)

Global Dim s_message.s(7)
s_message(0) = "WM_KEYDOWN"
s_message(1) = "WM_KEYUP"
s_message(2) = "WM_CHAR"
s_message(3) = "WM_DEADCHAR"
s_message(4) = "WM_SYSKEYDOWN"
s_message(5) = "WM_SYSKEYUP"
s_message(6) = "WM_SYSCHAR"
s_message(7) = "WM_SYSDEADCHAR" 

#KEYNAME_BUFFERSIZE =  32
Global *pmsg.MSG
*pmsg.MSG = #Null

Procedure main_callback(hwin, message, wparam, lparam)
    Static id_char_set = #DEFAULT_CHARSET
    Static client_width, client_height, client_max_width, client_max_height, char_width, char_height 
    ; PureBasic quirk? can't seem to declare and define more than one string per 'line' here
    ; Static yes.s = "Yes" ,no.s = "No" , down.s = "Down" 
    Static yes.s = "Yes" : Static no.s = "No" : Static down.s = "Down" 
    Static up.s = "Up"
    Static top.s = "Message        Key       Char    Repeat Scan Ext ALT Prev Tran"
    Static underline.s = "_______        ___       ____    ______ ____ ___ ___ ____ ____"
    Static c_max_lines, c_lines, rc_scroll.RECT  
    Define hdc, i, i_type
    Define tm.TEXTMETRIC
    Define s_buffer.s
    Dim chb_key_name.c(#KEYNAME_BUFFERSIZE-1)

    Select message
        Case #WM_INPUTLANGCHANGE, #WM_CREATE, #WM_DISPLAYCHANGE, #WM_SIZE
            If message = #WM_INPUTLANGCHANGE
                id_char_set = wparam
            EndIf 
            If message <> #WM_SIZE
                ; Get maximum size of client area
                client_max_width = GetSystemMetrics_(#SM_CXMAXIMIZED)
                client_max_height = GetSystemMetrics_(#SM_CYMAXIMIZED)
        
                ; Get character size for fixed-pitch font
                hdc = GetDC_(hwin)
        
                SelectObject_(hdc, CreateFont_(0, 0, 0, 0, 0, 0, 0, 0, id_char_set, 0, 0, 0, #FIXED_PITCH, #Null))  
                            
                GetTextMetrics_(hdc, tm)
                char_width = tm\tmAveCharWidth
                char_height = tm\tmHeight
                
                DeleteObject_(SelectObject_(hdc, GetStockObject_(#SYSTEM_FONT)))
                
                ReleaseDC_(hwin, hdc)
        
                ; Allocate memory for display lines
                If *pmsg
                    FreeMemory(*pmsg)
                EndIf
                c_max_lines = client_max_height / char_height
                *pmsg = AllocateMemory(c_max_lines * SizeOf(MSG))
                c_lines = 0
            Else
                client_width = LOWORD(lparam)
                client_height = HIWORD(lparam)
            EndIf

            ; Calculate scrolling rectangle
            rc_scroll\left   = 0
            rc_scroll\right  = client_width
            rc_scroll\top    = char_height
            rc_scroll\bottom = char_height*(client_height / char_height)
    
            InvalidateRect_(hwin, #Null, #True)

            If message = #WM_INPUTLANGCHANGE
                ProcedureReturn #True
            EndIf
       
        Case #WM_KEYDOWN, #WM_KEYUP, #WM_CHAR, #WM_DEADCHAR, #WM_SYSKEYDOWN, #WM_SYSKEYUP, #WM_SYSCHAR, #WM_SYSDEADCHAR 
            ; Rearrange storage array
            For i = (c_max_lines - 1)*SizeOf(MSG) To SizeOf(MSG) Step -SizeOf(MSG)
                CopyMemory(*pmsg + i - SizeOf(MSG), *pmsg + i, SizeOf(MSG))
            Next i

            ; Store new message
            *pmsg\hwnd = hwin
            *pmsg\message = message
            *pmsg\wparam = wparam
            *pmsg\lparam = lparam

            c_lines = min(c_lines + 1, c_max_lines)
    
            ; Scroll up the display
            ScrollWindow_(hwin, 0, -char_height, rc_scroll, rc_scroll)
    
            ; so sys messages work
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
        Case #WM_PAINT
        
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, CreateFont_(0, 0, 0, 0, 0, 0, 0, 0, id_char_set, 0, 0, 0, #FIXED_PITCH, #Null)) 
                            
            SetBkMode_(hdc, #TRANSPARENT)
            text_out(hdc, 0, 0, top)
            text_out(hdc, 0, 0, underline)

            Define *cur_msg.MSG, append.s
            For i = 0 To min(c_lines, Int(client_height / char_height)-1)-1 
                *cur_msg = *pmsg + i*SizeOf(MSG)
                Select *cur_msg\message 
                    Case #WM_CHAR, #WM_SYSCHAR, #WM_DEADCHAR, #WM_SYSDEADCHAR
                        i_type = 1
                    Default
                        i_type = 0
                EndSelect                 
    
                GetKeyNameText_(*cur_msg\lparam, chb_key_name(), #KEYNAME_BUFFERSIZE)
    
                s_buffer = LSet(s_message(*cur_msg\message - #WM_KEYFIRST), 13)                
                If i_type
                    s_buffer = s_buffer + "            $" + RSet(Hex(*cur_msg\wparam),4,"0")
                    s_buffer = s_buffer + " "
                    s_buffer = s_buffer + Chr(*cur_msg\wparam)
                    s_buffer = s_buffer + " " + RSet(Str(LOWORD(*cur_msg\lparam)),6)
                    s_buffer = s_buffer + " " + RSet(Str(HIWORD(*cur_msg\lparam) & $FF), 4)
                Else
                    s_buffer = s_buffer + " " + RSet(Str(*cur_msg\wparam), 3)
                    s_buffer = s_buffer + " " + LSet(PeekS(chb_key_name(), #KEYNAME_BUFFERSIZE), 15)
                    s_buffer = s_buffer + RSet(Str(LOWORD(*cur_msg\lparam)),6)
                    s_buffer = s_buffer + " " + RSet(Str(HIWORD(*cur_msg\lparam) & $FF), 4)
                EndIf
                If $01000000 & *cur_msg\lparam
                    append = yes
                Else
                    append = no
                EndIf
                s_buffer = s_buffer + " " + LSet(append, 3)
                If $20000000 & *cur_msg\lparam 
                    append = yes
                Else
                    append = no
                EndIf
                s_buffer = s_buffer + " " + LSet(append, 3)
                If $40000000 & *cur_msg\lparam 
                    append = down 
                Else
                    append = up
                EndIf
                s_buffer = s_buffer + " " + LSet(append, 4)
                If $80000000 & *cur_msg\lparam
                    append = up
                Else
                    append = down
                EndIf
                s_buffer = s_buffer + " " + LSet(append, 4)

                text_out(hdc, 0,(client_height / char_height - 1 - i) * char_height, s_buffer)
            Next i
          
          
            DeleteObject_(SelectObject_(hdc, GetStockObject_(#SYSTEM_FONT)))
            
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            If *pmsg
                FreeMemory(*pmsg)
            EndIf
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf        

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam