; connect.pb
; based on connect.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "connect", main_caption.s = "Connect-the-Points Mouse Demo"
Global hinstance = GetModuleHandle_(#NULL)

#MAXPOINTS = 1000

Procedure main_callback(hwin, message, wparam, lparam)
    Static point_count, last_tick_count
    Static Dim pt.POINT(#MAXPOINTS-1)
    Define hdc, i, j
    
    Select message
        Case #WM_LBUTTONDOWN
            point_count = 0
            last_tick_count = GetTickCount_()
            InvalidateRect_(hwin, #NULL, #True)
        case #WM_MOUSEMOVE
            ; modern pcs are a lot faster, so the original algorithm
            ; produced so many drawing points that the result was a
            ; featureless blob. The GetTickCount() modification
            ; allows you to see what the original was intended to look like, 
            ; regardless of pc speed.
            If wparam & #MK_LBUTTON and point_count < 1000 and GetTickCount_()-last_tick_count>70
                pt(point_count)\x = LOWORD(lparam)
                pt(point_count)\y = HIWORD(lparam)
                point_count+1
                last_tick_count = GetTickCount_()
                
                hdc = GetDC_(hwin)
                SetPixel_(hdc, LOWORD(lparam), HIWORD(lparam), 0)
                ReleaseDC_(hwin, hdc)
            EndIf
            
        Case #WM_LBUTTONUP
            InvalidateRect_(hwin, #NULL, #False)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SetCursor_(LoadCursor_(#NULL, #IDC_WAIT))
            ShowCursor_(#true)
            
            For i = 0 to point_count - 2
                For j = i + 1 to point_count-1
                    line_to(hdc, pt(i)\x, pt(i)\y, pt(j)\x, pt(j)\y)
                Next j
            Next i

            ShowCursor_(#False)
            SetCursor_(LoadCursor_(#NULL, #IDC_ARROW))
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf        

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam