; checker2.pb
; based on checker2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "checker2", main_caption.s = "Checker2 Mouse Hit-Test Demo"
Global hinstance = GetModuleHandle_(#NULL)

#DIVISIONS = 5

Procedure main_callback(hwin, message, wparam, lparam)
    Static block_width, block_height, x, y
    Static Dim f_state(#DIVISIONS-1,#DIVISIONS-1)
    Define hdc, rect.RECT, point.POINT

    Select message
        Case #WM_SIZE
            block_width = LOWORD(lparam) / #DIVISIONS
            block_height = HIWORD(lparam) / #DIVISIONS
        Case #WM_SETFOCUS
            ShowCursor_(#TRUE)
        Case #WM_KILLFOCUS 
            ShowCursor_(#FALSE)
        Case #WM_KEYDOWN 
            GetCursorPos_(point)
            ScreenToClient_(hwin, point)
            
            x = max(0, min(#DIVISIONS - 1, point\x / block_width))
            y = max(0, min(#DIVISIONS - 1, point\y / block_height))
            
            Select wparam
                Case #VK_UP 
                    y-1
                Case #VK_DOWN 
                    y+1
                Case #VK_LEFT 
                    x-1
                Case #VK_RIGHT 
                    x+1
                Case #VK_HOME 
                    x = y = 0
                Case #VK_END 
                    x = y = #DIVISIONS - 1
                Case #VK_RETURN, #VK_SPACE 
                    SendMessage_(hwin, #WM_LBUTTONDOWN, #MK_LBUTTON, MAKELONG(x * block_width, y * block_height))
            EndSelect
            x = (x + #DIVISIONS) % #DIVISIONS
            y = (y + #DIVISIONS) % #DIVISIONS
            
            point\x = x * block_width + block_width / 2
            point\y = y * block_height + block_height / 2
            
            ClientToScreen_(hwin, @point)
            SetCursorPos_(point\x, point\y)
        Case #WM_LBUTTONDOWN 
            x = LOWORD(lparam) / block_width
            y = HIWORD(lparam) / block_height
            
            If x < #DIVISIONS and y < #DIVISIONS
                f_state(x,y) ! 1

                rect\left   = x * block_width
                rect\top    = y * block_height
                rect\right  = (x + 1) * block_width
                rect\bottom = (y + 1) * block_height

                InvalidateRect_(hwin, rect, #FALSE)
            Else
                MessageBeep_(0)
            EndIf
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)

            For x = 0 to #DIVISIONS-1
                For y = 0 to #DIVISIONS-1
                    Rectangle_(hdc, x * block_width, y * block_height, (x + 1) * block_width,(y + 1) * block_height)
                        
                    If f_state(x,y)
                        line_to(hdc,  x    * block_width,  y    * block_height, (x+1) * block_width,(y+1) * block_height)
                        line_to(hdc,  x    * block_width,(y+1) * block_height, (x+1) * block_width,  y    * block_height)
                    EndIf
                Next y
            Next x
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam