; checker3.pb
; based on checker3.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "checker3", main_caption.s = "Checker3 Mouse Hit-Test Demo"
Global child_class_name.s = "Checker3_Child"
Global hinstance = GetModuleHandle_(#NULL)

#DIVISIONS = 5

Procedure child_callback(hwin, message, wparam, lparam)
    Define hdc, ps.PAINTSTRUCT, rect.RECT

    Select message
        Case #WM_CREATE
            SetWindowLongPtr_(hwin, 0, 0)  ; on/off flag
        Case #WM_LBUTTONDOWN
            SetWindowLongPtr_(hwin, 0, 1 ! GetWindowLongPtr_(hwin, 0))
            InvalidateRect_(hwin, #NULL, #FALSE)
        Case #WM_PAINT
            hdc = BeginPaint_(hwin, ps)

            GetClientRect_(hwin, rect)
            Rectangle_(hdc, 0, 0, rect\right, rect\bottom)

            If GetWindowLongPtr_(hwin, 0)
                line_to(hdc, 0,           0, rect\right, rect\bottom)
                line_to(hdc, 0, rect\bottom, rect\right,           0)
            EndIf

            EndPaint_(hwin, ps)
        Default:
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect
    ProcedureReturn 0
EndProcedure


Procedure main_callback(hwin, message, wparam, lparam)
    Static Dim hchild(#DIVISIONS-1, #DIVISIONS-1)
    Define block_width, block_height, x, y

    Select message
        Case #WM_CREATE
            Define child_class.WNDCLASS
            With child_class
                \lpfnWndProc = @child_callback()
                \cbWndExtra = SizeOf(INTEGER)
                \hinstance = hinstance
                \lpszClassName = @child_class_name
                \style = #CS_HREDRAW | #CS_VREDRAW
                \hcursor = LoadCursor_(0, #IDC_ARROW)
                \hbrBackground = #COLOR_WINDOW + 1
            EndWith
            RegisterClass_(child_class)

            For x = 0 to #DIVISIONS-1
                For y = 0 to #DIVISIONS-1
                    hchild(x,y) = CreateWindowEx_(#NULL,@child_class_name,#NULL, #WS_CHILDWINDOW | #WS_VISIBLE,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT, hwin, y << 8 | x,hinstance,#NULL)
                Next y
            Next x    
        Case #WM_SIZE
            block_width = LOWORD(lparam) / #DIVISIONS
            block_height = HIWORD(lparam) / #DIVISIONS

            For x = 0 to #DIVISIONS-1
                For y = 0 to #DIVISIONS-1
                    MoveWindow_(hchild(x,y), x * block_width, y * block_height, block_width, block_height, #TRUE)
                Next y
            Next x
        Case #WM_LBUTTONDOWN 
            MessageBeep_(0)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0 
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam