; blokout1.pb
; based on blokout1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "blokout1", main_caption.s = "Mouse Button Demo"
Global hinstance = GetModuleHandle_(#NULL)

#ESCAPE_CHAR = 27
Declare draw_box_outline(hwin, *pt_beg.POINT, *pt_End.POINT)

Procedure main_callback(hwin, message, wparam, lparam)
    Static f_blocking, f_valid_Box, pt_beg.POINT, pt_End.POINT, pt_box_beg.POINT, pt_box_End.POINT 
    Define hdc

    Select message
        Case #WM_LBUTTONDOWN 
            pt_beg\x = LOWORD(lparam)
            pt_End\x = LOWORD(lparam)
            pt_beg\y = HIWORD(lparam)
            pt_End\y = HIWORD(lparam)
            
            draw_box_outline(hwin, pt_beg, pt_End)
            
            SetCursor_(LoadCursor_(#NULL, #IDC_CROSS))
            
            f_blocking = #TRUE
        case #WM_MOUSEMOVE 
            If f_blocking
                SetCursor_(LoadCursor_(#NULL, #IDC_CROSS))
                
                draw_box_outline(hwin, pt_beg, pt_End)
                
                pt_End\x = LOWORD(lparam)
                pt_End\y = HIWORD(lparam)
                
                draw_box_outline(hwin, pt_beg, pt_End)
            EndIf 
        Case #WM_LBUTTONUP 
            If f_blocking
                draw_box_outline(hwin, pt_beg, pt_End)
                
                CopyMemory(pt_beg, pt_box_beg, SizeOf(POINT)) 
                pt_box_End\x = LOWORD(lparam)
                pt_box_End\y = HIWORD(lparam)
                
                SetCursor_(LoadCursor_(#NULL, #IDC_ARROW))
                
                f_blocking = #FALSE
                f_valid_Box  = #TRUE
                
                InvalidateRect_(hwin, #NULL, #TRUE)
            EndIf 
        Case #WM_CHAR 
            If f_blocking And (wparam = #ESCAPE_CHAR)    
                draw_box_outline(hwin, pt_beg, pt_End)
                
                SetCursor_(LoadCursor_(#NULL, #IDC_ARROW))
                
                f_blocking = #FALSE
            EndIf   
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            If f_valid_Box
                SelectObject_(hdc, GetStockObject_(#BLACK_BRUSH))
                Rectangle_(hdc, pt_box_beg\x, pt_box_beg\y, pt_box_End\x, pt_box_End\y)
            EndIf 
            
            If f_blocking
                SetROP2_(hdc, #R2_NOT)
                SelectObject_(hdc, GetStockObject_(#NULL_BRUSH))
                Rectangle_(hdc, pt_beg\x, pt_beg\y, pt_End\x, pt_End\y)
            EndIf 
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure draw_box_outline(hwin, *pt_beg.POINT, *pt_End.POINT)
    Define hdc = GetDC_(hwin)
    
    SetROP2_(hdc, #R2_NOT)
    SelectObject_(hdc, GetStockObject_(#NULL_BRUSH))
    Rectangle_(hdc, *pt_beg\x, *pt_beg\y, *pt_End\x, *pt_End\y)
    
    ReleaseDC_(hwin, hdc)
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
