; beeper1.pb
; based on beeper1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "beeper1", main_caption.s = "Beeper1 Timer Demo"
Global hinstance = GetModuleHandle_(#NULL)

#ID_TIMER  =  1

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, f_flip_flop = #FALSE
    Define hdc, hbrush
    
    Select message
        Case #WM_TIMER 
            MessageBeep_(-1)        
            f_flip_flop = 1 ! f_flip_flop
            InvalidateRect_(hwin, #NULL, #FALSE)
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE 
            SetTimer_(hwin, #ID_TIMER, 1000, #NULL)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT, rc.RECT, rgb_brush
            hdc = BeginPaint_(hwin, ps)

            GetClientRect_(hwin, rc)
            If f_flip_flop 
                rgb_brush = RGB(255,0,0) 
            Else
                rgb_brush = RGB(0,0,255)
            EndIf 
            hbrush = CreateSolidBrush_(rgb_brush)
            FillRect_(hdc, rc, hbrush)
          
            EndPaint_(hwin, ps)
            DeleteObject_(hbrush)
        Case #WM_DESTROY
            KillTimer_(hwin, #ID_TIMER)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam