; beeper2.pb
; based on beeper2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "beeper2", main_caption.s = "Beeper2 Timer Demo"
Global hinstance = GetModuleHandle_(#NULL)

#ID_TIMER  =  1

Declare timer_proc(hwnd, message, id_timer, ticks_from_sys_start)

Procedure main_callback(hwin, message, wparam, lparam)
    Select message
        Case #WM_CREATE 
            SetTimer_(hwin, #ID_TIMER, 1000, @timer_proc())
        Case #WM_DESTROY
            KillTimer_(hwin, #ID_TIMER)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure timer_proc(hwnd, message, id_timer, ticks_from_sys_start)
    static f_flip_flop = #FALSE
    Define hbrush, hdc, rc.RECT
    
    MessageBeep_(-1)
    f_flip_flop = 1 ! f_flip_flop
    
    GetClientRect_(hwnd, rc)
    
    hdc = GetDC_(hwnd)
    Define rgb_brush
    If f_flip_flop 
        rgb_brush = RGB(255,0,0) 
    Else
        rgb_brush = RGB(0,0,255)
    EndIf 
    hbrush = CreateSolidBrush_(rgb_brush)
    
    FillRect_(hdc, rc, hbrush)
    ReleaseDC_(hwnd, hdc)
    DeleteObject_(hbrush)
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam