; digclock.pb
; based on digclock.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "digclock", main_caption.s = "Digital Clock"
Global hinstance = GetModuleHandle_(#Null)

IncludePath ""
XIncludeFile "DigClock.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, f_24_Hour, f_suppress, hbrush_red
    Define hdc 
    
    Select message
        Case #WM_TIMER
            InvalidateRect_(hwin, #Null, #True)
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE, #WM_SETTINGCHANGE
            If message = #WM_CREATE  
                hbrush_red = CreateSolidBrush_(RGB(255, 0, 0))
                SetTimer_(hwin, #ID_TIMER, 1000, #Null)
            EndIf 

            Dim chb_leading_0.c(1)
            Dim chb_24.c(1)
            GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_ITIME, chb_24(), 2)
            If chb_24(0) = '1'  : f_24_Hour = #True
            Else                   : f_24_Hour = #False
            EndIf 

            GetLocaleInfo_(#LOCALE_USER_DEFAULT, #LOCALE_ITLZERO, chb_leading_0(), 2)
            If chb_leading_0(0) = '0'    : f_suppress = #True
            Else                         : f_suppress = #False
            EndIf
    
            InvalidateRect_(hwin, #Null, #True)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SetMapMode_(hdc, #MM_ISOTROPIC)
            SetWindowExtEx_(hdc, 276, 52, #Null)
            SetViewportExtEx_(hdc, client_width, client_height, #Null)
    
            SetWindowOrgEx_(hdc, 138, 36, #Null)
            SetViewportOrgEx_(hdc, client_width / 2, client_height / 2, #Null)
    
            SelectObject_(hdc, GetStockObject_(#NULL_PEN))
            SelectObject_(hdc, hbrush_red)
    
            display_time(hdc, f_24_Hour, f_suppress)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            KillTimer_(hwin, #ID_TIMER)
            DeleteObject_(hbrush_red)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#Null, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#Null,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#Null, #Null,hinstance,#Null)
        If Not hwin
            MessageBox_(#Null, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #Null, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 46
; FirstLine = 27
; Folding = -
; EnableUnicode
; EnableXP