;
; DigClock.pbi
;
#ID_TIMER = 1
Define x,y

Global Dim pt_colon.POINT(1,3)
Global Dim f_seven_segment.l(9,6)
Global Dim pt_segment.POINT(6,5)

DataSection
    colon_data:
    Data.i 2,21,  6,17, 10,21,  6,25, 2,51,  6,47, 10,51,  6,55

    seven_segment_led_data: ;[10][7]
    Data.i 1, 1, 1, 0, 1, 1, 1  ; 0
    Data.i 0, 0, 1, 0, 0, 1, 0  ; 1
    Data.i 1, 0, 1, 1, 1, 0, 1  ; 2
    Data.i 1, 0, 1, 1, 0, 1, 1  ; 3
    Data.i 0, 1, 1, 1, 0, 1, 0  ; 4
    Data.i 1, 1, 0, 1, 0, 1, 1  ; 5
    Data.i 1, 1, 0, 1, 1, 1, 1  ; 6
    Data.i 1, 0, 1, 0, 0, 1, 0  ; 7
    Data.i 1, 1, 1, 1, 1, 1, 1  ; 8
    Data.i 1, 1, 1, 1, 0, 1, 1  ; 9

    pt_segment_data: ;; [7][6]
    Data.i 7,  6,  11,  2,  31,  2,  35,  6,  31, 10,  11, 10
    Data.i 6,  7,  10, 11,  10, 31,   6, 35,   2, 31,   2, 11
    Data.i 36,  7,  40, 11,  40, 31,  36, 35,  32, 31,  32, 11
    Data.i 7, 36,  11, 32,  31, 32,  35, 36,  31, 40,  11, 40
    Data.i 6, 37,  10, 41,  10, 61,   6, 65,   2, 61,   2, 41
    Data.i 36, 37,  40, 41,  40, 61,  36, 65,  32, 61,  32, 41
    Data.i 7, 66,  11, 62,  31, 62,  35, 66,  31, 70,  11, 70
EndDataSection

Restore colon_data
For x = 0 To 1
    For y = 0 To 3
        Read pt_colon(x,y)\x
        Read pt_colon(x,y)\y
    Next y
Next x
Restore seven_segment_led_data
For x = 0 To 9
    For y = 0 To 6
        Read f_seven_segment(x,y)
    Next y
Next x
Restore pt_segment_data
For x = 0 To 6
    For y = 0 To 5
        Read pt_segment(x,y)\x
        Read pt_segment(x,y)\y
    Next y
Next x


Procedure display_digit(hdc, number)
    Define i_seg

    For i_seg = 0 To 6
        If f_seven_segment(number, i_seg)
            Polygon_(hdc, pt_segment(i_seg,0), 6)
        EndIf
    Next i_seg
EndProcedure

Procedure display_two_digits(hdc, number, f_suppress)
    If (Not f_suppress) Or (number / 10 <> 0)
        display_digit(hdc, number / 10)
    EndIf

    OffsetWindowOrgEx_(hdc, -42, 0, #Null)
    display_digit(hdc, number % 10)
    OffsetWindowOrgEx_(hdc, -42, 0, #Null)
EndProcedure


Procedure display_colon(hdc)

    Polygon_(hdc, pt_colon(0,0), 4)
    Polygon_(hdc, pt_colon(1,0), 4)

    OffsetWindowOrgEx_(hdc, -12, 0, #Null)
EndProcedure

Procedure display_time(hdc, f_24_Hour, f_suppress)
    Define st.SYSTEMTIME

    GetLocalTime_(st)

    If f_24_Hour
        display_two_digits(hdc, st\wHour, f_suppress)
    Else
        Define hr
        st\wHour % 12
        If st\wHour
            hr = st\wHour
        Else
            hr = 12
        EndIf
        display_two_digits(hdc, hr, f_suppress)
    EndIf

    display_colon(hdc)
    display_two_digits(hdc, st\wMinute, #False)
    display_colon(hdc)
    display_two_digits(hdc, st\wSecond, #False)
EndProcedure
