; clock.pb
; based on clock.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "clock", main_caption.s = "Analog Clock"
Global hinstance = GetModuleHandle_(#NULL)


#ID_TIMER = 1
#TWOPI = (2 * 3.14159)

IncludePath ""
XIncludeFile "Clock.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, st_previous.SYSTEMTIME
    Define f_change, st.SYSTEMTIME, hdc 
    
    Select message
        Case #WM_TIMER 
            GetLocalTime_(st)
                    
            f_change = (st\wHour <> st_previous\wHour) Or  (st\wMinute <> st_previous\wMinute)
            
            hdc = GetDC_(hwin)
            
            set_isotropic(hdc, client_width, client_height)
            
            SelectObject_(hdc, GetStockObject_(#WHITE_PEN))
            draw_hands(hdc, st_previous, f_change)
    
            SelectObject_(hdc, GetStockObject_(#BLACK_PEN))
            draw_hands(hdc, st, #TRUE)
    
            ReleaseDC_(hwin, hdc)
            
            CopyMemory(st, st_previous, SizeOf(SYSTEMTIME))
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE 
            SetTimer_(hwin, #ID_TIMER, 1000, #NULL)
            GetLocalTime_(st)
            CopyMemory(st, st_previous, SizeOf(SYSTEMTIME))
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            set_isotropic(hdc, client_width, client_height)
            draw_clock(hdc)
            draw_hands(hdc, st_previous, #TRUE)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            KillTimer_(hwin, #ID_TIMER)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
