; Clock.pb
;
Procedure set_isotropic(hdc, client_width, client_height)
    SetMapMode_(hdc, #MM_ISOTROPIC)
    SetWindowExtEx_(hdc, 1000, 1000, #NULL)
    SetViewportExtEx_(hdc, client_width / 2, -client_height / 2, #NULL)
    SetViewportOrgEx_(hdc, client_width / 2,  client_height / 2, #NULL)
EndProcedure

Procedure rotate_point(*pt.POINT, num, angle)
    Define i, pt_temp.POINT

    For i = 0 To num-1
        pt_temp\x = *pt\x * cos(#TWOPI * angle / 360) + *pt\y * sin(#TWOPI * angle / 360)
        pt_temp\y = *pt\y * cos(#TWOPI * angle / 360) - *pt\x * sin(#TWOPI * angle / 360)

        CopyMemory(pt_temp, *pt, SizeOf(POINT))

        *pt + SizeOf(POINT)
    Next i
EndProcedure

Procedure draw_clock(hdc)
    Define angle
    Dim pt.POINT(2)

    For angle = 0 To 359 Step 6
        pt(0)\x =   0
        pt(0)\y = 900

        rotate_point(pt(0), 1, angle)

        If angle % 5
            pt(2)\y =  33
        Else
            pt(2)\y =  100
        EndIf
        pt(2)\x = pt(2)\y

        pt(0)\x - pt(2)\x / 2
        pt(0)\y - pt(2)\y / 2

        pt(1)\x  = pt(0)\x + pt(2)\x
        pt(1)\y  = pt(0)\y + pt(2)\y

        SelectObject_(hdc, GetStockObject_(#BLACK_BRUSH))

        Ellipse_(hdc, pt(0)\x, pt(0)\y, pt(1)\x, pt(1)\y)
    Next angle
EndProcedure

DataSection
    hands_data:
    Data.i 0, -150, 100, 0, 0, 600, -100, 0, 0, -150
    Data.i 0, -200,  50, 0, 0, 800,  -50, 0, 0, -200
    Data.i 0,    0,   0, 0, 0,   0,    0, 0, 0,  800
EndDataSection
Global Dim pt.POINT(3,5)
Define i, j
For i = 0 To 3
    For j = 0 To 5
        Read pt(i,j)\x
        Read pt(i,j)\y
    Next j
Next i

Procedure draw_hands(hdc, *pst.SYSTEMTIME, f_change)
    Define i
    Dim pt_temp.POINT(2,4)
    Dim angle.l(3)

    angle(0) = (*pst\wHour * 30) % 360 + *pst\wMinute / 2
    angle(1) =  *pst\wMinute  *  6
    angle(2) =  *pst\wSecond  *  6

    CopyMemory(pt(), pt_temp(), SizeOf(POINT)*3*5)

    Define start
    If f_change  : start = 0
    Else        : start = 2
    EndIf

    For i = start To 2
        rotate_point(pt_temp(i,0), 5, angle(i))
        Polyline_(hdc, pt_temp(i,0), 5)
    Next i
EndProcedure
