; whatclr.pb
; based on whatclr.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "whatclr", main_caption.s = "What Color"
Global hinstance = GetModuleHandle_(#NULL)

Global display.s = "DISPLAY"
#ID_TIMER = 1

Procedure main_callback(hwin, message, wparam, lparam)
    Static cr, cr_last, hdc_screen
    Define hdc, pt.POINT, s_buffer.s
    
    Select message
        Case #WM_CREATE 
            hdc_screen = CreateDC_(@display, #NULL, #NULL, #NULL)
            SetTimer_(hwin, #ID_TIMER, 100, #NULL)
        Case #WM_DISPLAYCHANGE
            DeleteDC_(hdc_screen)
            hdc_screen = CreateDC_(@display, #NULL, #NULL, #NULL)
        Case #WM_TIMER
            GetCursorPos_(pt)
            cr = GetPixel_(hdc_screen, pt\x, pt\y)
            
            If cr <> cr_last
                cr_last = cr
                InvalidateRect_(hwin, #NULL, #FALSE)
            EndIf 
        Case #WM_PAINT
            Define ps.PAINTSTRUCT, rc.RECT
            hdc = BeginPaint_(hwin, ps)

            GetClientRect_(hwin, rc)

            s_buffer = "  " + RSet(Hex(Red(cr)),2,"0") + " " + RSet(Hex(Green(cr)),2,"0") + " " + RSet(Hex(Blue(cr)),2,"0")

            DrawText_(hdc, @s_buffer, -1, rc, #DT_SINGLELINE | #DT_CENTER | #DT_VCENTER)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            DeleteDC_(hdc_screen)
            KillTimer_(hwin, #ID_TIMER)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure find_window_size(*window_width, *window_height)
    Define hdc_screen, tm.TEXTMETRIC
    
    hdc_screen = CreateIC_(@display, #NULL, #NULL, #NULL)
    GetTextMetrics_(hdc_screen, tm)
    DeleteDC_(hdc_screen)
    
    PokeL(*window_width, 2 * GetSystemMetrics_(#SM_CXBORDER) + 12 * tm\tmAveCharWidth)
    PokeL(*window_height, 2 * GetSystemMetrics_(#SM_CYBORDER) + GetSystemMetrics_(#SM_CYCAPTION) +  2 * tm\tmHeight)
EndProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
    
    Define window_width, window_height
    find_window_size(@window_width, @window_height)

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption, #WS_OVERLAPPED | #WS_CAPTION | #WS_SYSMENU | #WS_BORDER,#CW_USEDEFAULT,#CW_USEDEFAULT,window_width,window_height,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam