; btnlook.pb
; based on btnlook.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "btnlook", main_caption.s = "Button Look"
Global hinstance = GetModuleHandle_(#NULL)

Structure button_type
    style.i
    text.s
EndStructure 

DataSection
    button_type_data: 
    Data.i #BS_PUSHBUTTON       :   Data.s "PUSHBUTTON"
    Data.i #BS_DEFPUSHBUTTON    :   Data.s "DEFPUSHBUTTON"
    Data.i #BS_CHECKBOX         :   Data.s "CHECKBOX"
    Data.i #BS_AUTOCHECKBOX     :   Data.s "AUTOCHECKBOX"
    Data.i #BS_RADIOBUTTON      :   Data.s "RADIOBUTTON"
    Data.i #BS_3STATE           :   Data.s "3STATE"
    Data.i #BS_AUTO3STATE       :   Data.s "AUTO3STATE"
    Data.i #BS_GROUPBOX         :   Data.s "GROUPBOX"
    Data.i #BS_AUTORADIOBUTTON  :   Data.s "AUTORADIO"
    Data.i #BS_OWNERDRAW        :   Data.s "OWNERDRAW"
EndDataSection 
#NUM = 10
Global Dim button.button_type(#NUM-1)
Restore button_type_data
Define i
For i = 0 To #NUM-1
    Read.i button(i)\style
    Read.s button(i)\text
Next i


Procedure main_callback(hwin, message, wparam, lparam)
    Define hdc, ps.PAINTSTRUCT, i
    Static Dim hwndButton.l(#NUM-1)
    Static rect.RECT, char_width, char_height
    Static top.s = "message          wparam      lparam"
    Static underline.s = "_______          ______      ______"
    Static s_buffer.s = ""

    Select message
        Case #WM_SIZE
            rect\left   = 24 * char_width
            rect\top    =  2 * char_height
            rect\right  = LOWORD(lparam)
            rect\bottom = HIWORD(lparam)
        Case #WM_CREATE 
            char_width = LOWORD(GetDialogBaseUnits_())
            char_height = HIWORD(GetDialogBaseUnits_())

                For i = 0 To #NUM - 1
                    hwndButton(i) = CreateWindow_(@WC_BUTTON,@button(i)\text,#WS_CHILD | #WS_VISIBLE | button(i)\style,char_width,char_height *(1 + 2 * i),20 * char_width,7 * char_height / 4,hwin, i,hinstance,#NULL)
                Next i
        Case #WM_PAINT
            InvalidateRect_(hwin, rect, #TRUE)
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            SetBkMode_(hdc, #TRANSPARENT)
            
            text_out(hdc, 24 * char_width, char_height, top)
            text_out(hdc, 24 * char_width, char_height, underline)
          
            EndPaint_(hwin, ps)
        Case #WM_DRAWITEM, #WM_COMMAND 
            ScrollWindow_(hwin, 0, -char_height, rect, rect)

            hdc = GetDC_(hwin)
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            
            If message = #WM_DRAWITEM   :   s_buffer = "WM_DRAWITEM"
            Else : s_buffer = "WM_COMMAND"
            EndIf 
            
            s_buffer = LSet(s_buffer, 16) + RSet(Hex(HIWORD(wparam)), 4, "0") + "-" + RSet(Hex(LOWORD(wparam)),4, "0") + "    " + RSet(Hex(HIWORD(lparam)), 4, "0") + "-" + RSet(Hex(LOWORD(lparam)),4, "0") 
            text_out(hdc, 24 * char_width, char_height*(rect\bottom / char_height - 1), s_buffer)
            
            ReleaseDC_(hwin, hdc)
            ValidateRect_(hwin, rect)
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam