; owndraw.pb
; based on owndraw.c by Charles Petzold, in PW5E
;
;IncludePath "..\"
XIncludeFile "..\petzold.pbi"

Global app_name.s = "owndraw", main_caption.s = "Owner-Draw Button Demo"
Global hinstance = GetModuleHandle_(#Null)

#ID_SMALLER = 1
#ID_LARGER = 2

Macro BTN_WIDTH  :(8 * char_width): EndMacro 
Macro BTN_HEIGHT :(4 * char_height):EndMacro 

Procedure triangle(hdc, *pt.POINT)
    SelectObject_(hdc, GetStockObject_(#BLACK_BRUSH))
    Polygon_(hdc, *pt, 3)
    SelectObject_(hdc, GetStockObject_(#WHITE_BRUSH))
EndProcedure 

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, char_width, char_height, hbtn_smaller, hbtn_larger
    Define hdc, cx, cy, rc.RECT 
    Dim pt.POINT(2)    
    
    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
            ; Move the buttons to the new center
            MoveWindow_(hbtn_smaller, client_width / 2 - 3 * BTN_WIDTH  / 2, client_height / 2 - BTN_HEIGHT / 2, BTN_WIDTH, BTN_HEIGHT, #True)
            MoveWindow_(hbtn_larger,  client_width / 2 + BTN_WIDTH  / 2, client_height / 2 - BTN_HEIGHT / 2, BTN_WIDTH, BTN_HEIGHT, #True)
        Case #WM_COMMAND 
            GetWindowRect_(hwin, rc)
            
            ; Make the window 10% smaller or larger
            Select wparam
                Case #ID_SMALLER
                    rc\left   + client_width / 20
                    rc\right  - client_width / 20
                    rc\top    + client_height / 20
                    rc\bottom - client_height / 20
                Case #ID_LARGER 
                    rc\left   - client_width / 20
                    rc\right  + client_width / 20
                    rc\top    - client_height / 20
                    rc\bottom + client_height / 20
            EndSelect 
            
            MoveWindow_(hwin, rc\left, rc\top, rc\right  - rc\left, rc\bottom - rc\top, #True)
        Case #WM_DRAWITEM 
            Define *pdis.DRAWITEMSTRUCT = lparam
            
            ; Fill area with white and frame it black            
            FillRect_(*pdis\hDC, *pdis\rcItem, GetStockObject_(#WHITE_BRUSH))
            
            FrameRect_(*pdis\hDC, *pdis\rcItem, GetStockObject_(#BLACK_BRUSH))
            
            ; Draw inward and outward black triangles
            cx = *pdis\rcItem\right  - *pdis\rcItem\left
            cy = *pdis\rcItem\bottom - *pdis\rcItem\top 
            
            Select *pdis\CtlID
                Case #ID_SMALLER 
                    pt(0)\x = 3 * cx / 8 :  pt(0)\y = 1 * cy / 8
                    pt(1)\x = 5 * cx / 8 :  pt(1)\y = 1 * cy / 8
                    pt(2)\x = 4 * cx / 8 :  pt(2)\y = 3 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 7 * cx / 8 :  pt(0)\y = 3 * cy / 8
                    pt(1)\x = 7 * cx / 8 :  pt(1)\y = 5 * cy / 8
                    pt(2)\x = 5 * cx / 8 :  pt(2)\y = 4 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 5 * cx / 8 :  pt(0)\y = 7 * cy / 8
                    pt(1)\x = 3 * cx / 8 :  pt(1)\y = 7 * cy / 8
                    pt(2)\x = 4 * cx / 8 :  pt(2)\y = 5 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 1 * cx / 8 :  pt(0)\y = 5 * cy / 8
                    pt(1)\x = 1 * cx / 8 :  pt(1)\y = 3 * cy / 8
                    pt(2)\x = 3 * cx / 8 :  pt(2)\y = 4 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                Case #ID_LARGER 
                    pt(0)\x = 5 * cx / 8 :  pt(0)\y = 3 * cy / 8
                    pt(1)\x = 3 * cx / 8 :  pt(1)\y = 3 * cy / 8
                    pt(2)\x = 4 * cx / 8 :  pt(2)\y = 1 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 5 * cx / 8 :  pt(0)\y = 5 * cy / 8
                    pt(1)\x = 5 * cx / 8 :  pt(1)\y = 3 * cy / 8
                    pt(2)\x = 7 * cx / 8 :  pt(2)\y = 4 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 3 * cx / 8 :  pt(0)\y = 5 * cy / 8
                    pt(1)\x = 5 * cx / 8 :  pt(1)\y = 5 * cy / 8
                    pt(2)\x = 4 * cx / 8 :  pt(2)\y = 7 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
                    
                    pt(0)\x = 3 * cx / 8 :  pt(0)\y = 3 * cy / 8
                    pt(1)\x = 3 * cx / 8 :  pt(1)\y = 5 * cy / 8
                    pt(2)\x = 1 * cx / 8 :  pt(2)\y = 4 * cy / 8
                    
                    triangle(*pdis\hDC, pt())
            EndSelect 
            
            ; Invert the rectangle if the button is selected
            If (*pdis\itemState & #ODS_SELECTED)
                InvertRect_(*pdis\hDC, *pdis\rcItem)
            EndIf 
            
            ; Draw a focus rectangle if the button has the focus            
            If (*pdis\itemState & #ODS_FOCUS)
                *pdis\rcItem\left   + cx / 16
                *pdis\rcItem\top    + cy / 16
                *pdis\rcItem\right  - cx / 16
                *pdis\rcItem\bottom - cy / 16
                
                DrawFocusRect_(*pdis\hDC, *pdis\rcItem)
            EndIf  
        Case #WM_CREATE  
            char_width = LOWORD(GetDialogBaseUnits_())
            char_height = HIWORD(GetDialogBaseUnits_())

            ; Create the owner-draw pushbuttons
            hbtn_smaller = CreateWindow_(@WC_BUTTON,#Null,#WS_CHILD | #WS_VISIBLE | #BS_OWNERDRAW,0,0,BTN_WIDTH,BTN_HEIGHT,hwin, #ID_SMALLER,hinstance,#Null)
            hbtn_larger  = CreateWindow_(@WC_BUTTON,#Null,#WS_CHILD | #WS_VISIBLE | #BS_OWNERDRAW,0,0,BTN_WIDTH,BTN_HEIGHT,hwin, #ID_LARGER,hinstance,#Null)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#Null, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#Null,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#Null, #Null,hinstance,#Null)
        If Not hwin
            MessageBox_(#Null, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #Null, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
; IDE Options = PureBasic 5.30 Beta 6 (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableXP