; colors1.pb
; based on colors1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "colors1", main_caption.s = "Color Scroll"
Global hinstance = GetModuleHandle_(#NULL)

Global id_focus
Global Dim scroll_callback_old(2)

Declare scroll_callback(hwnd, message, wparam, lparam)

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Define hdc, i, client_width, client_height, s_buffer.s
    Static Dim cr_prime(2) : Static Dim  hbrush(2) : Static Dim hscroll(2)
    Static Dim  hlbl_name(2) : Static Dim hlbl_value(2) : Static Dim color(3)
    Static Dim  color_text.s(2)    
    Static hbrush_static, hlbl_rect, char_height, rc_color.RECT

    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)

            SetRect_(rc_color, client_width / 2, 0, client_width, client_height)
            
            MoveWindow_(hlbl_rect, 0, 0, client_width / 2, client_height, #TRUE)
            
            For i = 0 To 2
                MoveWindow_(hscroll(i), (2 * i + 1) * client_width / 14, 2 * char_height, client_width / 14, client_height - 4 * char_height, #TRUE)
                MoveWindow_(hlbl_name(i), (4 * i + 1) * client_width / 28, char_height / 2, client_width / 7, char_height, #TRUE)
                MoveWindow_(hlbl_value(i), (4 * i + 1) * client_width / 28, client_height - 3 * char_height / 2, client_width / 7, char_height, #TRUE)
            Next i
            SetFocus_(hwin)
        Case #WM_CREATE 
            cr_prime(0) = RGB(255, 0, 0) : cr_prime(1) = RGB(0, 255, 0) : cr_prime(2) = RGB(0, 0, 255)
            color_text(0) = "Red" : color_text(1) = "Green" : color_text(2) = "Blue"

            ; Create the white-rectangle window against which the 
            ; scroll bars will be positioned. The child window ID is 9.
            hlbl_rect = CreateWindow_(@WC_STATIC,#NULL,#WS_CHILD | #WS_VISIBLE | #SS_WHITERECT,0,0,0,0,hwin,9,hinstance,#NULL)

            For i = 0 To 2
                ; The three scroll bars have IDs 0, 1, and 2, with
                ; scroll bar ranges from 0 through 255.
                hscroll(i) = CreateWindow_(@WC_SCROLLBAR,#NULL,#WS_CHILD | #WS_VISIBLE | #WS_TABSTOP | #SBS_VERT,0,0,0,0,hwin,i,hinstance,#NULL)

                SetScrollRange_(hscroll(i), #SB_CTL, 0, 255, #FALSE)
                SetScrollPos_(hscroll(i), #SB_CTL, 0, #FALSE);

                ; The three color-name labels have IDs 3, 4, and 5, 
                ; and text strings "Red", "Green", and "Blue".
                hlbl_name(i) = CreateWindow_(@WC_STATIC,@color_text(i),#WS_CHILD | #WS_VISIBLE | #SS_CENTER,0,0,0,0,hwin,i+3,hinstance,#NULL)

                ; The three color-value text fields have IDs 6, 7, 
                ; and 8, and initial text strings of "0".
                hlbl_value(i) = CreateWindow_(@WC_STATIC,@"0",#WS_CHILD | #WS_VISIBLE | #SS_CENTER,0,0,0,0,hwin,i+6,hinstance,#NULL)

                scroll_callback_old(i) = SetWindowLongPtr_(hscroll(i), #GWLP_WNDPROC, @scroll_callback())

                hbrush(i) = CreateSolidBrush_(cr_prime(i))
            Next i

            hbrush_static = CreateSolidBrush_(GetSysColor_(#COLOR_BTNHIGHLIGHT))

            char_height = HIWORD(GetDialogBaseUnits_())
        Case #WM_SETFOCUS 
            SetFocus_(hscroll(id_focus))
        Case #WM_VSCROLL 
            i = GetWindowLongPtr_(lparam, #GWL_ID)
            
            Select LOWORD(wparam)
                Case #SB_PAGEDOWN, #SB_LINEDOWN
                    If wparam = #SB_PAGEDOWN
                        color(i) + 15
                    EndIf 
                    color(i) = min(255, color(i) + 1)
                Case #SB_PAGEUP, #SB_LINEUP
                    If wparam = #SB_PAGEUP 
                        color(i) - 15
                    EndIf 
                    color(i) = max(0, color(i) - 1)
                Case #SB_TOP 
                    color(i) = 0
                Case #SB_BOTTOM 
                    color(i) = 255
                Case #SB_THUMBPOSITION, #SB_THUMBTRACK 
                    color(i) = HIWORD(wparam)
            EndSelect 
            SetScrollPos_(hscroll(i), #SB_CTL, color(i), #TRUE)
            SetWindowText_(hlbl_value(i), Str(color(i)))
            
            DeleteObject_(SetClassLongPtr_(hwin, #GCL_HBRBACKGROUND, CreateSolidBrush_(RGB(color(0), color(1), color(2)))))
            
            InvalidateRect_(hwin, rc_color, #TRUE)
        Case #WM_CTLCOLORSCROLLBAR 
            i = GetWindowLongPtr_(lparam, #GWL_ID)
            ProcedureReturn hbrush(i)                
        Case #WM_CTLCOLORSTATIC 
            i = GetWindowLongPtr_(lparam, #GWL_ID)
                
            If i >= 3 And i <= 8  ; static text controls
                SetTextColor_(wparam, cr_prime(i % 3))
                SetBkColor_(wparam, GetSysColor_(#COLOR_BTNHIGHLIGHT))
                ProcedureReturn hbrush_static
            EndIf 
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)                
        Case #WM_SYSCOLORCHANGE 
            DeleteObject_(hbrush_static)
            hbrush_static = CreateSolidBrush_(GetSysColor_(#COLOR_BTNHIGHLIGHT))
        Case #WM_DESTROY
            DeleteObject_( SetClassLongPtr_( hwin, #GCL_HBRBACKGROUND, GetStockObject_(#WHITE_BRUSH)))
                
            For i = 0 To 2
                DeleteObject_(hbrush(i))
            Next i
                
            DeleteObject_(hbrush_static)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure scroll_callback(hwin, message, wparam, lparam)
    Define id = GetWindowLongPtr_(hwin, #GWL_ID)

    Select message
        Case #WM_KEYDOWN 
            If wparam = #VK_TAB
                Define key_state.w = GetKeyState_(#VK_SHIFT)
                If key_state < 0
                    Define shiftState = 2
                Else
                    shiftState = 1
                EndIf
                SetFocus_(GetDlgItem_(GetParent_(hwin), ((id + shiftState) % 3)))
            EndIf 
        Case #WM_SETFOCUS
            id_focus = id
    EndSelect
    ProcedureReturn CallWindowProc_(scroll_callback_old(id), hwin, message, wparam, lparam)
EndProcedure 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = CreateSolidBrush_(0)
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam