; environ.pb
; based on environ.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "environ", main_caption.s = "Environment List Box"
Global hinstance = GetModuleHandle_(#NULL)

#ID_LIST  = 1
#ID_TEXT  = 2

IncludePath ""
XIncludeFile "Environ.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    static hlistbox, hlbl
    Define i, length, char_width, char_height, *pvar_name.c, *pvar_value.c

    Select message
        Case #WM_SETFOCUS 
            SetFocus_(hlistbox)
        Case #WM_COMMAND 
            If LOWORD(wparam) = #ID_LIST And HIWORD(wparam) = #LBN_SELCHANGE
                ; Get current selection.
                i  = SendMessage_(hlistbox, #LB_GETCURSEL, 0, 0)
                length = SendMessage_(hlistbox, #LB_GETTEXTLEN, i, 0) + 1
                *pvar_name = AllocateMemory(length * SizeOf(CHAR))
                SendMessage_(hlistbox, #LB_GETTEXT, i, *pvar_name)
    
                ; Get environment string.
                length = GetEnvironmentVariable_(*pvar_name, #NULL, 0)
                If length
                    *pvar_value = AllocateMemory(length * SizeOf(CHAR))
                    GetEnvironmentVariable_(*pvar_name, *pvar_value, length)
    
                    ; Show it in window.
                    SetWindowText_(hlbl, PeekS(*pvar_value))
                    FreeMemory(*pvar_value)
                EndIf 
                FreeMemory(*pvar_name)
            EndIf 
        Case #WM_CREATE 
            char_width = LOWORD(GetDialogBaseUnits_())
            char_height = HIWORD(GetDialogBaseUnits_())
    
            ; Create listbox and static text windows.
            hlistbox = CreateWindow_(@WC_LISTBOX,#NULL,#WS_CHILD | #WS_VISIBLE | #LBS_STANDARD,char_width,char_height * 3,char_width * 25 + GetSystemMetrics_(#SM_CXVSCROLL),char_height * 20,hwin, #ID_LIST,hinstance,#NULL)

            hlbl = CreateWindow_(@WC_STATIC,#NULL,#WS_CHILD | #WS_VISIBLE | #SS_LEFT,char_width,char_height,GetSystemMetrics_(#SM_CXSCREEN),char_height,hwin,#ID_TEXT, hinstance,#NULL)

            fill_list_box(hlistbox)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam