; head.pb
; based on head.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "head", main_caption.s = "Head"
Global hinstance = GetModuleHandle_(#NULL)

Import "user32.lib"
    DrawTextA_(hdc, ptext, textLen, rc, flags) As "_DrawTextA@20"
EndImport

#ID_LIST = 1
#ID_TEXT = 2

#MAXREAD = 8192
#DIRATTR = #DDL_READWRITE | #DDL_READONLY | #DDL_HIDDEN | #DDL_SYSTEM | #DDL_DIRECTORY | #DDL_ARCHIVE  | #DDL_DRIVES
#DTFLAGS = #DT_WORDBREAK | #DT_EXPANDTABS | #DT_NOCLIP | #DT_NOPREFIX

Global *old_listbox_callback

Procedure listbox_callback(hwin, message, wparam, lparam)
    If message = #WM_KEYDOWN and wparam = #VK_RETURN
        SendMessage_(GetParent_(hwin), #WM_COMMAND, MAKELONG(1, #LBN_DBLCLK), hwin)
    EndIf
    ProcedureReturn CallWindowProc_(*old_listbox_callback, hwin, message, wparam, lparam)
EndProcedure


Procedure main_callback(hwin, message, wparam, lparam)
    Define hdc, hfile, i, char_width, char_height, ps.PAINTSTRUCT
    static f_valid_file, hlistbox, hlbl, rect.RECT 
    static Dim b_buffer.b(#MAXREAD-1)
    static Dim chb_file.c(#MAX_PATH)
    Dim s_buffer.c(#MAX_PATH)
    
    Select message
        Case #WM_CREATE
            char_width = LOWORD(GetDialogBaseUnits_())
            char_height = HIWORD(GetDialogBaseUnits_())
            
            rect\left = char_width * 27 + GetSystemMetrics_(#SM_CXVSCROLL)
            rect\top  =  3 * char_height
            
            hlistbox = CreateWindow_(@WC_LISTBOX,#NULL,#WS_CHILD | #WS_VISIBLE | #LBS_STANDARD,char_width,char_height*3,char_width * 25 + GetSystemMetrics_(#SM_CXVSCROLL),char_height * 20,hwin,#ID_LIST,hinstance,#NULL)

            GetCurrentDirectory_(#MAX_PATH + 1, s_buffer())
            hlbl = CreateWindow_(@WC_STATIC,s_buffer(),#WS_CHILD | #WS_VISIBLE | #SS_LEFT,0,char_height,char_width * #MAX_PATH,char_height,hwin,#ID_TEXT,hinstance,#NULL)
            
            *old_listbox_callback = SetWindowLongPtr_(hlistbox, #GWLP_WNDPROC, @listbox_callback())
            
            SendMessage_(hlistbox, #LB_DIR, #DIRATTR, @"*.*")
        Case #WM_SIZE 
            rect\right  = LOWORD(lparam)
            rect\bottom = HIWORD(lparam)
        Case #WM_SETFOCUS 
            SetFocus_(hlistbox)
        Case #WM_COMMAND 
            If LOWORD(wparam) = #ID_LIST And HIWORD(wparam) = #LBN_DBLCLK
                i = SendMessage_(hlistbox, #LB_GETCURSEL, 0, 0)
                If #LB_ERR = i
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
                EndIf 
                
                SendMessage_(hlistbox, #LB_GETTEXT, i, s_buffer())

                hfile = CreateFile_(s_buffer(), #GENERIC_READ, #FILE_SHARE_READ, #NULL, #OPEN_EXISTING, 0, #NULL)
                If #INVALID_HANDLE_VALUE <> hfile    
                    CloseHandle_(hfile)
                    f_valid_file = #TRUE
                    
                    PokeS(chb_file(), PeekS(s_buffer()))
                    GetCurrentDirectory_(#MAX_PATH + 1, s_buffer())
    
                    If s_buffer(MemoryStringLength(s_buffer()) - 1) <> '\'
                        lstrcat_(s_buffer(), @"\")
                    EndIf
                    lstrcat_(s_buffer(), chb_file())
                    SetWindowText_(hlbl, PeekS(s_buffer()))
                Else
                    f_valid_file = #FALSE
                    s_buffer(MemoryStringLength(s_buffer()) - 1) = 0
    
                    ; If setting the directory doesn't work, maybe it's
                    ; a drive change, so try that.    
                    If Not SetCurrentDirectory(PeekS(s_buffer() + SizeOf(CHAR)))
                        s_buffer(3) = ':'
                        s_buffer(4) = 0
                        SetCurrentDirectory(PeekS(s_buffer() + 2*SizeOf(CHAR)))
                    EndIf 
                    ; Get the new directory name and fill the list box.
                    GetCurrentDirectory_(#MAX_PATH + 1, s_buffer())
                    SetWindowText_(hlbl, PeekS(s_buffer()))
                    SendMessage_(hlistbox, #LB_RESETCONTENT, 0, 0)
                    SendMessage_(hlistbox, #LB_DIR, #DIRATTR, @"*.*");
                EndIf 
                InvalidateRect_(hwin, #NULL, #TRUE)
            EndIf 
        Case #WM_PAINT
            If Not f_valid_file
                ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndIf 
            hfile = CreateFile_(chb_file(), #GENERIC_READ, #FILE_SHARE_READ, #NULL, #OPEN_EXISTING, 0, #NULL)
            If #INVALID_HANDLE_VALUE = hfile
                f_valid_file = #FALSE
                ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndIf 
    
            ReadFile_(hfile, b_buffer(), #MAXREAD, @i, #NULL)
            CloseHandle_(hfile)
    
            ; i now equals the number of bytes in b_buffer.
            ; Commence getting a device context for displaying text.
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            SetTextColor_(hdc, GetSysColor_(#COLOR_BTNTEXT))
            SetBkColor_(hdc, GetSysColor_(#COLOR_BTNFACE))
    
            ; Assume the file is ASCII    
            DrawTextA_(hdc, b_buffer(), i, rect, #DTFLAGS)
          
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_BTNFACE + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam