; poepoem.pb
; based on poepoem.C by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "", main_caption.s = ""
Global hinstance = GetModuleHandle_(#NULL)

Import "user32.lib"
    DrawTextA_(hdc, ptext, textLen, rc, flags) As "_DrawTextA@20"
    LoadStringA_(hinstance,	uID, lpBuffer, nBufferMax) As "_LoadStringA@16"
    MessageBoxA_(hWnd, lpText, lpCaption, uType) As "_MessageBoxA@16"
EndImport

#IDS_APPNAME = 1
#IDS_CAPTION = 2
#IDS_ERRMSG = 3

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height, *text, hresource, hscroll, position, char_width, char_height, num_lines, vscroll_width 
    Define hdc, rect.RECT, tm.TEXTMETRIC

    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
            MoveWindow_(hscroll, client_width - vscroll_width, 0, vscroll_width, client_height, #TRUE)
            SetFocus_(hwin)
        Case #WM_SETFOCUS 
            SetFocus_(hscroll)
        Case #WM_VSCROLL 
            Select wparam
                Case #SB_TOP :           position = 0
                Case #SB_BOTTOM :        position = num_lines
                Case #SB_LINEUP :        position - 1
                Case #SB_LINEDOWN :      position + 1
                Case #SB_PAGEUP :        position - client_height / char_height
                Case #SB_PAGEDOWN :      position + client_height / char_height
                Case #SB_THUMBPOSITION : position = LOWORD(lparam)
            EndSelect 
            position = max(0, min(position, num_lines))
            
            If position <> GetScrollPos_(hscroll, #SB_CTL)
                SetScrollPos_(hscroll, #SB_CTL, position, #TRUE)
                InvalidateRect_(hwin, #NULL, #TRUE)
            EndIf 
        Case #WM_CREATE 
            hdc = GetDC_(hwin)
            GetTextMetrics_(hdc, tm)
            char_width = tm\tmAveCharWidth
            char_height = tm\tmHeight + tm\tmExternalLeading
            ReleaseDC_(hwin, hdc)
            
            vscroll_width = GetSystemMetrics_(#SM_CXVSCROLL)
            
            hscroll = CreateWindow_(@WC_SCROLLBAR,#NULL,#WS_CHILD | #WS_VISIBLE | #SBS_VERT,0,0,0,0,hwin,1,hinstance,#NULL)
            
            hresource = LoadResource_(hinstance, FindResource_(hinstance, @"AnnabelLee", @"TEXT"))
            
            *text = LockResource_(hresource)
            num_lines = 0;
            ;
            ; This text file resource is ASCII, regardless of our compile mode
            ;            
            While PeekB(*text) <> '\' and PeekB(*text) <> 0
                If PeekB(*text) = 10
                    num_lines + 1
                EndIf 
                *text = CharNext_(*text)
            Wend 
            PokeB(*text, 0)
            
            SetScrollRange_(hscroll, #SB_CTL, 0, num_lines, #FALSE)
            SetScrollPos_(hscroll, #SB_CTL, 0, #FALSE)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)
            
            *text = LockResource_(hresource)
                
            GetClientRect_(hwin, rect)
            rect\left + char_width
            rect\top  + (char_height *(1 - position))
            DrawTextA_(hdc, *text, -1, rect, #DT_EXTERNALLEADING)
    
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            FreeResource_(hresource) ;only necessary on win95?
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Dim szAppName.c(15)
    Dim szCaption.c(63)
    Dim szErrMsg.c(63)

    LoadString_(hinstance, #IDS_APPNAME, szAppName(), 16)
    LoadString_(hinstance, #IDS_CAPTION, szCaption(), 64)

    app_name = PeekS(szAppname())
    main_caption = PeekS(szCaption())

    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(hinstance, @app_name)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            LoadStringA_(hinstance, #IDS_APPNAME, @app_name, 16)
            LoadStringA_(hinstance, #IDS_ERRMSG, szErrMsg(), 64)
            MessageBoxA_(#NULL, szErrMsg(), szAppName(), #MB_ICONERROR)
    
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam