; menudemo.pb
; based on menudemo.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "menudemo.pbi"

Global app_name.s = "menudemo", main_caption.s = "Menu Demonstration"
Global hinstance = GetModuleHandle_(#NULL)

#ID_TIMER = 1

Procedure main_callback(hwin, message, wparam, lparam)
    Static Dim id_color(4)  
    Static id_selection = #IDM_BKGND_WHITE

    Select message
        Case #WM_COMMAND
            Define id = LOWORD(wparam)

            Define hmenu = GetMenu_(hwin)

            Select id
                Case #IDM_EDIT_UNDO, #IDM_EDIT_CUT, #IDM_EDIT_COPY, #IDM_EDIT_PASTE, #IDM_EDIT_CLEAR
                    MessageBeep_(0)
                Case #IDM_FILE_NEW, #IDM_FILE_OPEN, #IDM_FILE_SAVE, #IDM_FILE_SAVE_AS 
                    MessageBeep_(0)
                Case #IDM_APP_EXIT
                    SendMessage_(hwin, #WM_CLOSE, 0, 0)
                Case #IDM_BKGND_WHITE,  #IDM_BKGND_LTGRAY, #IDM_BKGND_GRAY, #IDM_BKGND_DKGRAY, #IDM_BKGND_BLACK     
                  ; Note: Logic below assumes that IDM_WHITE through IDM_BLACK are consecutive numbers in the order shown here.
                    CheckMenuItem_(hmenu, id_selection, #MF_UNCHECKED)
                    id_selection = LOWORD(wparam)
                    CheckMenuItem_(hmenu, id_selection, #MF_CHECKED)
                    
                    SetClassLongPtr_(hwin, #GCL_HBRBACKGROUND, GetStockObject_(id_color(LOWORD(wparam) - #IDM_BKGND_WHITE)))
                    
                    InvalidateRect_(hwin, #NULL, #TRUE)
                Case #IDM_TIMER_START
                    If SetTimer_(hwin, #ID_TIMER, 1000, #NULL)
                        EnableMenuItem_(hmenu, #IDM_TIMER_START, #MF_GRAYED)
                        EnableMenuItem_(hmenu, #IDM_TIMER_STOP,  #MF_ENABLED)
                    EndIf 
                Case #IDM_TIMER_STOP
                    KillTimer_(hwin, #ID_TIMER)
                    EnableMenuItem_(hmenu, #IDM_TIMER_START, #MF_ENABLED)
                    EnableMenuItem_(hmenu, #IDM_TIMER_STOP,  #MF_GRAYED)
                Case #IDM_APP_HELP
                    MessageBox_(hwin, "Help not yet implemented!", app_name, #MB_ICONEXCLAMATION | #MB_OK)
                Case #IDM_APP_ABOUT
                    MessageBox_(hwin, "Menu Demonstration Program" + Chr(10) + "based on a C version that is (c) Charles Petzold, 1998", app_name, #MB_ICONINFORMATION | #MB_OK)
                Default
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)            
            EndSelect
        Case #WM_TIMER
            MessageBeep_(0)
        Case #WM_CREATE
            id_color(0) = #WHITE_BRUSH
            id_color(1) = #LTGRAY_BRUSH
            id_color(2) = #GRAY_BRUSH
            id_color(3) = #DKGRAY_BRUSH
            id_color(4) = #BLACK_BRUSH 
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam