; poormenu.pb
; based on poormenu.C by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "poormenu", main_caption.s = "The Poor-Person's Menu"
Global hinstance = GetModuleHandle_(#NULL)

#IDM_SYS_ABOUT = 1
#IDM_SYS_HELP = 2
#IDM_SYS_REMOVE = 3

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Define hdc
    
    Select message
        Case #WM_SYSCOMMAND
            Select LOWORD(wparam)
                Case #IDM_SYS_ABOUT
                    MessageBox_(hwin, "A Poor-Person's Menu Program" + Chr(10) + "based on a C version that is (c) Charles Petzold, 1998", app_name, #MB_OK | #MB_ICONINFORMATION)
                Case #IDM_SYS_HELP
                    MessageBox_(hwin, "Help not yet implemented!", app_name, #MB_OK | #MB_ICONEXCLAMATION)
                Case #IDM_SYS_REMOVE
                    GetSystemMenu_(hwin, #TRUE)
                Default
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)                
            EndSelect
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default 
        ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 
    ProcedureReturn 0

EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hmenu = GetSystemMenu_(hwin, #FALSE)
    AppendMenu_(hmenu, #MF_SEPARATOR, 0,         #NULL)
    AppendMenu_(hmenu, #MF_STRING, #IDM_SYS_ABOUT,  @"About...")
    AppendMenu_(hmenu, #MF_STRING, #IDM_SYS_HELP,   @"Help...")
    AppendMenu_(hmenu, #MF_STRING, #IDM_SYS_REMOVE, @"Remove Additions")

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam