; nopopups.pb
; based on nopopups.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "nopopups.pbi"

Global app_name.s = "nopopups", main_caption.s = "No-Popup Nested Menu Demonstration"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static hmnu_main, hmnu_edit, hmnu_file

    Select message
        Case #WM_CREATE 
            hmnu_main = LoadMenu_(hinstance, @"MenuMain")
            hmnu_file = LoadMenu_(hinstance, @"MenuFile")
            hmnu_edit = LoadMenu_(hinstance, @"MenuEdit")
            
            SetMenu_(hwin, hmnu_main)

        Case #WM_COMMAND
             ; cheat sheet:
             ; code = 0, is hmenu message : code = 1, is accelerator message : otherwise is control message and code is notification code
            Define id = LOWORD(wparam)
            Select id
                Case #IDM_MAIN
                    SetMenu_(hwin, hmnu_main)
                Case #IDM_FILE
                    SetMenu_(hwin, hmnu_file)
                Case #IDM_EDIT
                    SetMenu_(hwin, hmnu_edit)
                Case #IDM_FILE_NEW, #IDM_FILE_OPEN, #IDM_FILE_SAVE, #IDM_FILE_SAVE_AS, #IDM_EDIT_UNDO, #IDM_EDIT_CUT, #IDM_EDIT_COPY, #IDM_EDIT_PASTE, #IDM_EDIT_CLEAR
                    MessageBeep_(0)
            EndSelect 
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
        Case #WM_DESTROY
            SetMenu_(hwin, hmnu_main)
            DestroyMenu_(hmnu_file)
            DestroyMenu_(hmnu_edit)

            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam