; poppad2.pb
; based on poppad2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "poppad2.pbi"

Global app_name.s = "poppad2", main_caption.s = "PopPad2"
Global hinstance = GetModuleHandle_(0)

Procedure ask_confirmation(hwin)
    ProcedureReturn MessageBox_(hwin, "Really want to close PopPad2?", app_name, #MB_YESNO | #MB_ICONQUESTION)
EndProcedure

Procedure main_callback(hwin, message, wparam, lparam)
    Static hedit
    Define sel_range, f_enable

    Select message
        Case #WM_INITMENUPOPUP
            If lparam = 1
                If SendMessage_(hedit, #EM_CANUNDO, 0, 0) 
                    Define enable_state = #MF_ENABLED
                Else
                    enable_state = #MF_GRAYED
                EndIf 
                EnableMenuItem_(wparam, #IDM_EDIT_UNDO, enable_state)
                
                If IsClipboardFormatAvailable_(#CF_TEXT)  
                    enable_state = #MF_ENABLED
                Else 
                    enable_state = #MF_GRAYED
                EndIf 
                EnableMenuItem_(wparam, #IDM_EDIT_PASTE, enable_state)
                
                sel_range = SendMessage_(hedit, #EM_GETSEL, 0, 0)
                
                If HIWORD(sel_range) = LOWORD(sel_range)
                    f_enable = #MF_GRAYED
                Else
                    f_enable = #MF_ENABLED
                EndIf 
                
                EnableMenuItem_(wparam, #IDM_EDIT_CUT,   f_enable)
                EnableMenuItem_(wparam, #IDM_EDIT_COPY,  f_enable)
                EnableMenuItem_(wparam, #IDM_EDIT_CLEAR, f_enable)
            Else
                ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndIf 
        Case #WM_SETFOCUS 
            SetFocus_(hedit)
        Case #WM_SIZE  
            MoveWindow_(hedit, 0, 0, LOWORD(lparam), HIWORD(lparam), #TRUE)
        Case #WM_COMMAND 
             ; code = 0, is hmenu message : code = 1, is accelerator message : otherwise is control message and code is notification code
            Define id = LOWORD(wparam), code = HIWORD(wparam)
            ;;;;;, hctrl = lparam
            If id = #ID_EDIT
                If code = #EN_ERRSPACE Or code = #EN_MAXTEXT
                    MessageBox_(hwin, "Edit control out of space.", app_name, #MB_OK | #MB_ICONSTOP)
                EndIf 
            Else
                Select id
                    Case #IDM_FILE_NEW, #IDM_FILE_OPEN, #IDM_FILE_SAVE, #IDM_FILE_SAVE_AS, #IDM_FILE_PRINT
                        MessageBeep_(0)
                    Case #IDM_APP_EXIT
                        SendMessage_(hwin, #WM_CLOSE, 0, 0)
                    Case #IDM_EDIT_UNDO
                        SendMessage_(hedit, #WM_UNDO, 0, 0)
                    Case #IDM_EDIT_CUT
                        SendMessage_(hedit, #WM_CUT, 0, 0)
                    Case #IDM_EDIT_COPY
                        SendMessage_(hedit, #WM_COPY, 0, 0)
                    Case #IDM_EDIT_PASTE
                        SendMessage_(hedit, #WM_PASTE, 0, 0)
                    Case #IDM_EDIT_CLEAR
                        SendMessage_(hedit, #WM_CLEAR, 0, 0)
                    Case #IDM_EDIT_SELECT_ALL
                        SendMessage_(hedit, #EM_SETSEL, 0, -1)
                    Case #IDM_HELP_HELP
                        MessageBox_(hwin, "Help not yet implemented!", app_name, #MB_OK | #MB_ICONEXCLAMATION)
                    Case #IDM_APP_ABOUT
                        MessageBox_(hwin, "POPPAD2" + Chr(10) + "Based on a C version that is (c) Charles Petzold, 1998", app_name, #MB_OK | #MB_ICONINFORMATION)
                    Default
                        ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
                EndSelect 
            EndIf 
        Case #WM_CREATE 
            hedit = CreateWindow_(@WC_EDIT,#NULL,#WS_CHILD | #WS_VISIBLE | #WS_HSCROLL | #WS_VSCROLL | #WS_BORDER | #ES_LEFT | #ES_MULTILINE | #ES_AUTOHSCROLL | #ES_AUTOVSCROLL,0,0,0,0,HWIN,#ID_EDIT,hinstance,#NULL)
        Case #WM_CLOSE
            If #IDYES = ask_confirmation(hwin)
                DestroyWindow_(hwin)
            EndIf 
        Case #WM_QUERYENDSESSION
            If #IDYES = ask_confirmation(hwin)   : ProcedureReturn 1
            Else                                : ProcedureReturn 0
            EndIf 
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(hinstance, @app_name)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
    EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,GetSystemMetrics_(#SM_CXSCREEN) / 4,GetSystemMetrics_(#SM_CYSCREEN) / 4,GetSystemMetrics_(#SM_CXSCREEN) / 2,GetSystemMetrics_(#SM_CYSCREEN) / 2,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define hAccel = LoadAccelerators_(hinstance, @app_name)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        If Not TranslateAccelerator_(hwin, hAccel, msg)
            TranslateMessage_(msg)
            DispatchMessage_(msg)
        EndIf
    Wend

End msg\wparam