#IDC_BLACK = 1000
#IDC_BLUE = 1001
#IDC_GREEN = 1002
#IDC_CYAN = 1003
#IDC_RED = 1004
#IDC_MAGENTA = 1005
#IDC_YELLOW = 1006
#IDC_WHITE = 1007
#IDC_RECT = 1008
#IDC_ELLIPSE = 1009
#IDC_PAINT = 1010
#IDM_APP_ABOUT = 40001

Define id_cur_color  = #IDC_BLACK, id_cur_figure = #IDC_RECT

Dim rgb_color(7)
rgb_color(0) = RGB(  0,   0, 0)
rgb_color(1) = RGB(  0,   0, 255)
rgb_color(2) = RGB(  0, 255, 0)
rgb_color(3) = RGB(  0, 255, 255)
rgb_color(4) = RGB(255,   0, 0)
rgb_color(5) = RGB(255,   0, 255)
rgb_color(6) = RGB(255, 255, 0)
rgb_color(7) = RGB(255, 255, 255)

Procedure paint_window(hwin, iColor, iFigure)
  Shared rgb_color()
    Define hbrush, hdc, rect.RECT

    hdc = GetDC_(hwin)
    GetClientRect_(hwin, rect)
    hbrush = CreateSolidBrush_(rgb_color(iColor - #IDC_BLACK))
    hbrush = SelectObject_(hdc, hbrush)

    If iFigure = #IDC_RECT
        Rectangle_(hdc, rect\left, rect\top, rect\right, rect\bottom)
    Else
        Ellipse_(hdc, rect\left, rect\top, rect\right, rect\bottom)
    EndIf

    DeleteObject_(SelectObject_(hdc, hbrush))
    ReleaseDC_(hwin, hdc)
EndProcedure

Procedure paint_the_block(hctrl, iColor, iFigure)
    InvalidateRect_(hctrl, #NULL, #TRUE)
    UpdateWindow_(hctrl)
    paint_window(hctrl, iColor, iFigure)
EndProcedure


Procedure about_callback(hdlg, message, wparam, lparam)
  Shared id_cur_color, id_cur_figure
    Static hlbl_block, id_color, id_figure

    Select message
        Case #WM_INITDIALOG
            id_color  = id_cur_color
            id_figure = id_cur_figure

            CheckRadioButton_(hdlg, #IDC_BLACK, #IDC_WHITE, id_color)
            CheckRadioButton_(hdlg, #IDC_RECT,  #IDC_ELLIPSE, id_figure)

            hlbl_block = GetDlgItem_(hdlg, #IDC_PAINT)

            SetFocus_(GetDlgItem_(hdlg, id_color))
            ProcedureReturn #FALSE
        Case #WM_COMMAND
            Define id = LOWORD(wparam)
            Select id
                Case #IDOK
                    id_cur_color  = id_color
                    id_cur_figure = id_figure
                    EndDialog_(hdlg, #TRUE)
                    ProcedureReturn #TRUE
                Case #IDCANCEL
                    EndDialog_(hdlg, #FALSE)
                    ProcedureReturn #TRUE
                Case #IDC_BLACK, #IDC_RED, #IDC_GREEN, #IDC_YELLOW, #IDC_BLUE, #IDC_MAGENTA, #IDC_CYAN, #IDC_WHITE
                    id_color = id
                    CheckRadioButton_(hdlg, #IDC_BLACK, #IDC_WHITE, id)
                    paint_the_block(hlbl_block, id_color, id_figure)
                    ProcedureReturn #TRUE
                Case #IDC_RECT, #IDC_ELLIPSE
                    id_figure = LOWORD(wparam);
                    CheckRadioButton_(hdlg, #IDC_RECT, #IDC_ELLIPSE, id)
                    paint_the_block(hlbl_block, id_color, id_figure)
                    ProcedureReturn #TRUE
            EndSelect
        Case #WM_PAINT
            paint_the_block(hlbl_block, id_color, id_figure)
    EndSelect
    ProcedureReturn #FALSE
EndProcedure
