; about3.pb
; based on about3.c by Charles Petzold, in PW5E
; 
IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "about3.pbi"

Global app_name.s = "about3", main_caption.s = "About Box Demo Program"
Global hinstance = GetModuleHandle_(#NULL)

Procedure about_callback(hdlg, message, wparam, lparam)
    Select message
        Case #WM_INITDIALOG
            ProcedureReturn #TRUE
        Case #WM_COMMAND
            Define id = LOWORD(wparam)
            Select id
                case #IDOK
                    EndDialog_(hdlg, 0)
                    ProcedureReturn #TRUE
            EndSelect
    EndSelect
    ProcedureReturn #FALSE
EndProcedure

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Define hdc
    
    Select message
        Case #WM_COMMAND
            Define id = LOWORD(wparam)
            Select id
                Case #IDM_APP_ABOUT
                    DialogBox_(hinstance, @"AboutBox", hwin, @about_callback())
                    ProcedureReturn 0
            EndSelect
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure btn_elliptic_callback(hwin, message, wparam, lparam)
    Dim text.c(40)
    Define hbrush, hdc, ps.PAINTSTRUCT, rect.RECT

    Select message
        Case #WM_PAINT
            GetClientRect_(hwin, rect)
            GetWindowText_(hwin, text(), 40)

            hdc = BeginPaint_(hwin, ps)

            hbrush = CreateSolidBrush_(GetSysColor_(#COLOR_WINDOW))
            hbrush = SelectObject_(hdc, hbrush)
            SetBkColor_(hdc, GetSysColor_(#COLOR_WINDOW))
            SetTextColor_(hdc, GetSysColor_(#COLOR_WINDOWTEXT))

            Ellipse_(hdc, rect\left, rect\top, rect\right, rect\bottom)
            DrawText_(hdc, text(), -1, rect, #DT_SINGLELINE | #DT_CENTER | #DT_VCENTER)

            DeleteObject_(SelectObject_(hdc, hbrush))

            EndPaint_(hwin, ps)
            ProcedureReturn 0
        Case #WM_KEYUP, #WM_LBUTTONUP
            If message <> #WM_KEYUP or wparam = #VK_SPACE
                SendMessage_(GetParent_(hwin), #WM_COMMAND, GetWindowLongPtr_(hwin, #GWLP_ID), hwin)
                ProcedureReturn 0
            EndIf
    EndSelect
    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
EndProcedure


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(hinstance, @app_name)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define ellipClass.WNDCLASS
        With ellipClass
            \lpfnWndProc = @btn_elliptic_callback()
            \hinstance = hinstance
            \lpszClassName = @"EllipPush"
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_BTNFACE + 1
        EndWith
        If Not RegisterClass_(ellipClass)
            MessageBox_(#NULL, "Cannot register Ellipse Window Class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf 

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam