; colors2.pb
; based on colors2.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "colors2", main_caption.s = "Color Scroll"
Global hinstance = GetModuleHandle_(#NULL)

Global hdlg_modeless

Procedure main_callback(hwin, message, wparam, lparam)
    
    Select message
        Case #WM_DESTROY
            DeleteObject_( SetClassLongPtr_(hwin, #GCLP_HBRBACKGROUND, GetStockObject_(#WHITE_BRUSH)))
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

Procedure color_scroll_callback(hdlg, message, wparam, lparam)
    Static Dim color(2)
    Define hparent, hscroll, id_ctrl, index

    Select message
        Case #WM_INITDIALOG
            For id_ctrl = 10 To 12
                hscroll = GetDlgItem_(hdlg, id_ctrl)
                SetScrollRange_(hscroll, #SB_CTL, 0, 255, #FALSE)
                SetScrollPos_(hscroll, #SB_CTL, 0, #FALSE)
            Next id_ctrl
            ProcedureReturn #TRUE

        Case #WM_VSCROLL
            hscroll   = lparam
            id_ctrl = GetWindowLongPtr_(hscroll, #GWLP_ID)
            index  = id_ctrl - 10
            hparent = GetParent_(hdlg)

            Select LOWORD(wparam)
                Case #SB_PAGEDOWN, #SB_LINEDOWN
                    If LOWORD(wparam) = #SB_PAGEDOWN
                        color(index) + 15
                    EndIf
                    color(index) = min(255, color(index) + 1)
                Case #SB_PAGEUP, #SB_LINEUP
                    If LOWORD(wparam) = #SB_PAGEUP
                        color(index) - 15
                    EndIf
                    color(index) = max(0, color(index) - 1)
                Case #SB_TOP
                    color(index) = 0
                Case #SB_BOTTOM
                    color(index) = 255
                Case #SB_THUMBPOSITION, #SB_THUMBTRACK
                    color(index) = HIWORD(wparam)
                Default
                    ProcedureReturn #FALSE
            EndSelect
            SetScrollPos_(hscroll, #SB_CTL,     color(index), #TRUE)
            SetDlgItemInt_(hdlg,  id_ctrl + 3, color(index), #FALSE)

            DeleteObject_(SetClassLongPtr_(hparent, #GCLP_HBRBACKGROUND, CreateSolidBrush_(RGB(color(0), color(1), color(2)))))

            InvalidateRect_(hparent, #NULL, #TRUE)
            ProcedureReturn #TRUE
    EndSelect
    ProcedureReturn #FALSE
EndProcedure

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = CreateSolidBrush_(0)
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    hdlg_modeless = CreateDialog_(hinstance, @"COLORSCRDLG", hwin, @color_scroll_callback())

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        If hdlg_modeless = 0 Or Not IsDialogMessage_(hdlg_modeless, msg)
            TranslateMessage_(msg)
            DispatchMessage_(msg)
        EndIf
    Wend

End msg\wparam