; hexcalc.pb
; based on hexcalc.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "hexcalc"
Global hinstance = GetModuleHandle_(#NULL)

IncludePath ""
XIncludeFile "hexcalc.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static f_new_number = #TRUE, operation = '=', number.q, first_num
    Define hbtn

    Select message
        Case #WM_KEYDOWN  ; left arrow --> backspace
            If wparam = #VK_LEFT
                wparam = #VK_BACK
                Goto main_callback_WM_CHAR  ; fall through
            EndIf
        Case #WM_CHAR
            main_callback_WM_CHAR:
            wparam = CharUpper_(wparam)
            If wparam = #VK_RETURN
                wparam = '='
            EndIf

            hbtn = GetDlgItem_(hwin, wparam)
            If hbtn
                SendMessage_(hbtn, #BM_SETSTATE, 1, 0)
                Delay(100)
                SendMessage_(hbtn, #BM_SETSTATE, 0, 0)
                Goto main_callback_WM_COMMAND ; fall through
            Else
                MessageBeep_(0)
            EndIf
        Case #WM_COMMAND
            main_callback_WM_COMMAND:
            Define lo = LOWORD(wparam)
            SetFocus_(hwin)

            Select lo
                Case #VK_BACK
                    number = Int(number/16)
                    show_number(hwin, number)
                Case #VK_ESCAPE
                    number = 0
                    show_number(hwin, number)
                Case #VK_0 to #VK_9, #VK_A To #VK_F           ;;  isxdigit(lo)
                    If f_new_number
                        first_num = number
                        number = 0
                    EndIf
                    f_new_number = #FALSE

                    Define n_adj

                    If number <= (#MAXDWORD >> 4)
                        If wparam >= '0' And wparam <= '9'
                            n_adj = '0'
                        Else
                            n_adj = 'A' - 10
                        EndIf
                        number = 16 * number + wparam - n_adj
                        show_number(hwin, number)
                    Else
                        MessageBeep_(0)
                    EndIf
                Default            ;; operation
                    If Not f_new_number
                        number = calc_it(first_num, operation, number)
                        show_number(hwin, number)
                    EndIf
                    f_new_number = #TRUE
                    operation = lo
            EndSelect
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(hinstance, @app_name)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_BTNFACE + 1
            \cbWndExtra = #DLGWINDOWEXTRA
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf

    Define hwin = CreateDialog_(hinstance, @app_name, 0, #NULL)
        If Not hwin
                MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam