; clipview.pb
; based on clipview.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "clipview", main_caption.s = "Simple Clipboard Viewer (Text Only)"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    static hnext_viewer;
    Define hglobal, *pGlobal

    Select message
        Case #WM_DRAWCLIPBOARD
            If hnext_viewer
                SendMessage_(hnext_viewer, message, wparam, lparam)
            EndIf
            InvalidateRect_(hwin, #NULL, #TRUE)
        Case #WM_CHANGECBCHAIN
            If  wparam = hnext_viewer
                hnext_viewer = lparam
            ElseIf hnext_viewer
                SendMessage_(hnext_viewer, message, wparam, lparam)
            EndIf
        Case #WM_CREATE
            hnext_viewer = SetClipboardViewer_(hwin)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT, rect.RECT
            Define hdc = BeginPaint_(hwin, ps)
            
            GetClientRect_(hwin, rect)
            OpenClipboard_(hwin)

            CompilerIf #PB_Compiler_Unicode = 1
                hglobal = GetClipboardData_(#CF_UNICODETEXT)
            CompilerElse
                hglobal = GetClipboardData_(#CF_TEXT)
            CompilerEndIf
            

            If hglobal <> #NULL
                *pGlobal = GlobalLock_(hglobal)
                DrawText_(hdc, *pGlobal, -1, rect, #DT_EXPANDTABS)
                GlobalUnlock_(hglobal)
            EndIf

            CloseClipboard_()

            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            ChangeClipboardChain_(hwin, hnext_viewer)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam