; devcaps2.pb
; based on devcaps2.C by Charles Petzold, in PW5E
; N.B. Petzold's original buffer size for the device name buffer is too small
; for some of the modern devices (e.g. "Microsoft Document Image Writer"), so
; I increased it to 300.

IncludePath "..\"
XIncludeFile "petzold.pbi"
IncludePath ""
XIncludeFile "devcaps2.pbi"

global app_name.s = "devcaps2", main_caption.s = "Device Capabilities"
Global hinstance = GetModuleHandle_(#NULL)

#SZ_DEVICE_STRING_BUFFER_SIZE = 300
Procedure main_callback(hwin, message, wparam, lparam)
    Define i, hdc, ps.PAINTSTRUCT, tm.TEXTMETRIC, hdc_info, hmenu, hprint
    Static fs_device.s{#SZ_DEVICE_STRING_BUFFER_SIZE}
    Static char_width, char_height, id_cur_device = #IDM_SCREEN, id_cur_info = #IDM_BASIC
    Static cb_needed.l, cb_returned.l
    Static *info4.PRINTER_INFO_4, *info5.PRINTER_INFO_5
    
    Select message
        Case #WM_CREATE, #WM_SETTINGCHANGE, #WM_COMMAND
            Select message
                Case #WM_CREATE, #WM_SETTINGCHANGE
                    If message = #WM_CREATE
                        hdc = GetDC_(hwin)

                        SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))

                        GetTextMetrics_(hdc, tm)
                        char_width = tm\tmAveCharWidth

                        char_height = tm\tmHeight + tm\tmExternalLeading

                        ReleaseDC_(hwin, hdc)
                    EndIf 

                    hmenu = GetSubMenu_(GetMenu_(hwin), 0)

                    While GetMenuItemCount_(hmenu) > 1
                        DeleteMenu_(hmenu, 1, #MF_BYPOSITION)
                    Wend


                    ; Get a list of all local and remote printers
                    ;
                    ; First, find out how large an array we need; this
                    ;   call will fail, leaving the required size in cb_needed
                    ;
                    ; Next, allocate space for the info array and fill it
                    ;
                    ; Put the printer names on the hmenu.
                    If GetVersion_() & $80000000    ; Windows 98
                        EnumPrinters_(#PRINTER_ENUM_LOCAL, #NULL, 5, #NULL, 0, @cb_needed, @cb_returned)

                        *info5 = AllocateMemory(cb_needed)

                        EnumPrinters_(#PRINTER_ENUM_LOCAL, #NULL, 5, *info5, cb_needed, @cb_needed, @cb_returned)


                        Define *prn_info5.PRINTER_INFO_5, f_append_menu, max_device_name_len
                        max_device_name_len = 0

                        For i = 0 To cb_returned - 1
                            If (i+1) % 16
                                f_append_menu = 0
                            Else
                                f_append_menu =  #MF_MENUBARBREAK
                            EndIf
                            *prn_info5 = *info5 + i*SizeOf(PRINTER_INFO_5)
                            AppendMenu_(hmenu, f_append_menu, i + 1, *prn_info5\pPrinterName)
                            Define prn_name_len = lstrlen_(*prn_info5\pPrinterName)
                            If prn_name_len > max_device_name_len
                                max_device_name_len = prn_name_len
                            EndIf
                        Next i
                        FreeMemory(*info5)
                    Else                         ; Windows NT
                        EnumPrinters_(#PRINTER_ENUM_LOCAL, #NULL, 4, #NULL, 0, @cb_needed, @cb_returned)

                        *info4 = AllocateMemory(cb_needed)

                        EnumPrinters_(#PRINTER_ENUM_LOCAL, #NULL, 4, *info4, cb_needed, @cb_needed, @cb_returned)

                        Define *prn_info4.PRINTER_INFO_4
                        max_device_name_len = 0
                        For i = 0 To cb_returned - 1
                            If (i+1) % 16
                                f_append_menu = 0
                            Else
                                f_append_menu =  #MF_MENUBARBREAK
                            EndIf
                            *prn_info4 = *info4 + i*SizeOf(PRINTER_INFO_4)
                            AppendMenu_(hmenu, f_append_menu, i + 1, *prn_info4\pPrinterName)
                            prn_name_len = lstrlen_(*prn_info4\pPrinterName)
                            If prn_name_len > max_device_name_len
                                max_device_name_len = prn_name_len
                            EndIf
                        Next i
                        FreeMemory(*info4)
                    EndIf

                    AppendMenu_(hmenu, #MF_SEPARATOR, 0, #NULL)
                    AppendMenu_(hmenu, 0, #IDM_DEVMODE, @"Properties")

                    wparam = #IDM_SCREEN
            EndSelect   

            hmenu = GetMenu_(hwin)

            If LOWORD(wparam) = #IDM_SCREEN or LOWORD(wparam) < #IDM_DEVMODE   ; IDM_SCREEN & Printers
                CheckMenuItem_(hmenu, id_cur_device, #MF_UNCHECKED)
                id_cur_device = LOWORD(wparam)
                CheckMenuItem_(hmenu, id_cur_device, #MF_CHECKED)
            ElseIf LOWORD(wparam) = #IDM_DEVMODE ; Properties selection
                GetMenuString_(hmenu, id_cur_device, @fs_device, #SZ_DEVICE_STRING_BUFFER_SIZE, #MF_BYCOMMAND)

                If OpenPrinter_(@fs_device, @hprint, #NULL)
                    PrinterProperties_(hwin, hprint)
                    ClosePrinter_(hprint)
                EndIf
            Else                     ; info hmenu items
                CheckMenuItem_(hmenu, id_cur_info, #MF_UNCHECKED)
                id_cur_info = LOWORD(wparam)
                CheckMenuItem_(hmenu, id_cur_info, #MF_CHECKED)
            EndIf
            InvalidateRect_(hwin, #NULL, #TRUE)
        Case #WM_INITMENUPOPUP
            If lparam = 0
                If id_cur_device = #IDM_SCREEN
                    Define enabled = #MF_GRAYED
                Else
                    enabled = #MF_ENABLED
                EndIf
                EnableMenuItem_(GetMenu_(hwin), #IDM_DEVMODE, enabled)
            EndIf
        Case #WM_PAINT
            main_caption = "Device Capabilities: "

            If id_cur_device = #IDM_SCREEN
                lstrcpy_(@fs_device, @"DISPLAY")
                hdc_info = CreateIC_(@fs_device, #NULL, #NULL, #NULL)
            Else
                hmenu = GetMenu_(hwin)

                GetMenuString_(hmenu, id_cur_device, @fs_device, #SZ_DEVICE_STRING_BUFFER_SIZE, #MF_BYCOMMAND)

                hdc_info = CreateIC_(#NULL, @fs_device, #NULL, #NULL)
            EndIf

            main_caption + fs_device
            SetWindowText_(hwin, main_caption)

            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)

            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))


            If hdc_info
                Select id_cur_info
                    Case #IDM_BASIC
                        do_basic_info(hdc, hdc_info, char_width, char_height)
                    Case #IDM_OTHER
                        do_other_info(hdc, hdc_info, char_width, char_height)
                    Case #IDM_CURVE, #IDM_LINE, #IDM_POLY, #IDM_TEXT
                        do_bit_coded_caps(hdc, hdc_info, char_width, char_height, id_cur_info - #IDM_CURVE)
                EndSelect
                DeleteDC_(hdc_info)
            EndIf


            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam