
#IDM_SCREEN = 40001
#IDM_BASIC = 40002
#IDM_OTHER = 40003
#IDM_CURVE = 40004
#IDM_LINE = 40005
#IDM_POLY = 40006
#IDM_TEXT = 40007
#IDM_DEVMODE = 1000
Structure dev_info
    index.l
    desc.s
EndStructure
DataSection
    basic_info:
     Data.l #HORZSIZE        : Data.s "HORZSIZE       Width in millimeters:"
     Data.l #VERTSIZE        : Data.s "VERTSIZE       Height in millimeters:"
     Data.l #HORZRES         : Data.s "HORZRES        Width in pixels:"
     Data.l #VERTRES         : Data.s "VERTRES        Height in raster lines:"
     Data.l #BITSPIXEL       : Data.s "BITSPIXEL      Color bits per pixel:"
     Data.l #PLANES          : Data.s "PLANES         Number of color planes:"
     Data.l #NUMBRUSHES      : Data.s "NUMBRUSHES     Number of device brushes:"
     Data.l #NUMPENS         : Data.s "NUMPENS        Number of device pens:"
     Data.l #NUMMARKERS      : Data.s "NUMMARKERS     Number of device markers:"
     Data.l #NUMFONTS        : Data.s "NUMFONTS       Number of device fonts:"
     Data.l #NUMCOLORS       : Data.s "NUMCOLORS      Number of device colors:"
     Data.l #PDEVICESIZE     : Data.s "PDEVICESIZE    Size of device structure:"
     Data.l #ASPECTX         : Data.s "ASPECTX        Relative width of pixel:"
     Data.l #ASPECTY         : Data.s "ASPECTY        Relative height of pixel:"
     Data.l #ASPECTXY        : Data.s "ASPECTXY       Relative diagonal of pixel:"
     Data.l #LOGPIXELSX      : Data.s "LOGPIXELSX     Horizontal dots per inch:"
     Data.l #LOGPIXELSY      : Data.s "LOGPIXELSY     Vertical dots per inch:"
     Data.l #SIZEPALETTE     : Data.s "SIZEPALETTE    Number of palette entries:"
     Data.l #NUMRESERVED     : Data.s "NUMRESERVED    Reserved palette entries:"
     Data.l #COLORRES        : Data.s "COLORRES       Actual color resolution:"
     Data.l #PHYSICALWIDTH   : Data.s "PHYSICALWIDTH   Printer page pixel width:"
     Data.l #PHYSICALHEIGHT  : Data.s "PHYSICALHEIGHT  Printer page pixel height:"
     Data.l #PHYSICALOFFSETX : Data.s "PHYSICALOFFSETX Printer page x offset:"
     Data.l #PHYSICALOFFSETY : Data.s "PHYSICALOFFSETY Printer page y offset:"
EndDataSection
#NUMLINES = 24 

Procedure do_basic_info(hdc, hdc_info, char_width, char_height)
    Define i, info.dev_info
    Restore basic_info
    For i = 0 To #NUMLINES-1
        Read.l info\index
        Read.s info\desc
        Define buffer.s = LSet(info\desc, 45) + RSet(Str(GetDeviceCaps_(hdc_info, info\index)),8)
        text_out(hdc, char_width, (i+1) * char_height, buffer)
    Next i
EndProcedure


Structure BITS
    imask.l
    desc.s
EndStructure
DataSection
    raster_cap_info:
       Data.l #RC_BITBLT       : Data.s "RC_BITBLT       Capable of simple BitBlt:"
       Data.l #RC_BANDING      : Data.s "RC_BANDING      Requires banding support:"
       Data.l #RC_SCALING      : Data.s "RC_SCALING      Requires scaling support:"
       Data.l #RC_BITMAP64     : Data.s "RC_BITMAP64     Supports bitmaps >64K:"
       Data.l #RC_GDI20_OUTPUT : Data.s "RC_GDI20_OUTPUT Has 2.0 output calls:"
       Data.l #RC_DI_BITMAP    : Data.s "RC_DI_BITMAP    Supports DIB to memory:"
       Data.l #RC_PALETTE      : Data.s "RC_PALETTE      Supports a palette:"
       Data.l #RC_DIBTODEV     : Data.s "RC_DIBTODEV     Supports bitmap conversion:"
       Data.l #RC_BIGFONT      : Data.s "RC_BIGFONT      Supports fonts >64K:"
       Data.l #RC_STRETCHBLT   : Data.s "RC_STRETCHBLT   Supports StretchBlt:"
       Data.l #RC_FLOODFILL    : Data.s "RC_FLOODFILL    Supports FloodFill:"
       Data.l #RC_STRETCHDIB   : Data.s "RC_STRETCHDIB   Supports StretchDIBits:"
    tech_info:
       Data.s "DT_PLOTTER(Vector plotter)"
       Data.s "DT_RASDISPLAY(Raster display)"
       Data.s "DT_RASPRINTER(Raster printer)"
       Data.s "DT_RASCAMERA(Raster camera)"
       Data.s "DT_CHARSTREAM(Character stream)"
       Data.s "DT_METAFILE(Metafile)"
       Data.s "DT_DISPFILE(Display file)"
EndDataSection
#NUMRASTERINFOLINES = 12
#NUMTECHINFOLINES = 7

Procedure do_other_info(hdc, hdc_info, char_width, char_height)
    Define i

    Define clip.BITS
    clip\iMask = #CP_RECTANGLE
    clip\desc = "CP_RECTANGLE    Can Clip To Rectangle:"

    Restore raster_cap_info
    Dim raster.BITS(#NUMRASTERINFOLINES-1)
    For i = 0 To #NUMRASTERINFOLINES-1
        Read.l raster(i)\imask
        Read.s raster(i)\desc
    Next i

    Restore tech_info
    Dim szTech.s(#NUMTECHINFOLINES-1)
    For i = 0 To #NUMTECHINFOLINES-1
        Read.s szTech(i)
    Next i

    Define s_buffer.s = LSet("DRIVERVERSION:", 24) + RSet(Hex(GetDeviceCaps_(hdc_info, #DRIVERVERSION)),4,"0")
    text_out(hdc, char_width, char_height, s_buffer)

    s_buffer = LSet("TECHNOLOGY:", 24) + LSet(szTech(GetDeviceCaps_(hdc_info, #TECHNOLOGY)), 40)
    text_out(hdc, char_width, 2 * char_height, s_buffer)


    text_out(hdc, char_width, 4 * char_height, "CLIPCAPS(Clipping capabilities)")
    If GetDeviceCaps_(hdc_info, #CLIPCAPS) & clip\iMask
        Define capabilityPresent.s = "Yes"
    else
        capabilityPresent.s = "No"
    EndIf
    s_buffer = LSet(clip\desc,45) +  " " + RSet(capabilityPresent,3)
    text_out(hdc, 9 * char_width, 6*char_height, s_buffer)


    text_out(hdc, char_width, 8 * char_height, "RASTERCAPS(Raster capabilities)")
        
    For i = 0 To #NUMRASTERINFOLINES-1
        If GetDeviceCaps_(hdc_info, #RASTERCAPS) & raster(i)\iMask
            capabilityPresent.s = "Yes"
        else
            capabilityPresent.s = "No"
        EndIf


        s_buffer = LSet(raster(i)\desc,45) + " " + RSet(capabilityPresent, 3)
        text_out(hdc, 9 * char_width,(i + 10) * char_height, s_buffer)
    Next i
    
EndProcedure


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; some data For do_bit_coded_caps() routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DataSection
    curves_data:
       Data.l #CC_CIRCLES     : Data.s "CC_CIRCLES    Can do circles:"
       Data.l #CC_PIE         : Data.s "CC_PIE        Can do pie wedges:"
       Data.l #CC_CHORD       : Data.s "CC_CHORD      Can do chord arcs:"
       Data.l #CC_ELLIPSES    : Data.s "CC_ELLIPSES   Can do ellipses:"
       Data.l #CC_WIDE        : Data.s "CC_WIDE       Can do wide borders:"
       Data.l #CC_STYLED      : Data.s "CC_STYLED     Can do styled borders:"
       Data.l #CC_WIDESTYLED  : Data.s "CC_WIDESTYLED Can do wide and styled borders:"
       Data.l #CC_INTERIORS   : Data.s "CC_INTERIORS  Can do interiors:"

    lines_data:
       Data.l #LC_POLYLINE    : Data.s "LC_POLYLINE   Can do polyline:"
       Data.l #LC_MARKER      : Data.s "LC_MARKER     Can do markers:"
       Data.l #LC_POLYMARKER  : Data.s "LC_POLYMARKER Can do polymarkers"
       Data.l #LC_WIDE        : Data.s "LC_WIDE       Can do wide lines:"
       Data.l #LC_STYLED      : Data.s "LC_STYLED     Can do styled lines:"
       Data.l #LC_WIDESTYLED  : Data.s "LC_WIDESTYLED Can do wide and styled lines:"
       Data.l #LC_INTERIORS   : Data.s "LC_INTERIORS  Can do interiors:"


    poly_data:
       Data.l #PC_POLYGON     : Data.s "PC_POLYGON     Can do alternate fill polygon:"
       Data.l #PC_RECTANGLE   : Data.s "PC_RECTANGLE   Can do rectangle:"
       Data.l #PC_WINDPOLYGON : Data.s "PC_WINDPOLYGON Can do winding number fill polygon:"
       Data.l #PC_SCANLINE    : Data.s "PC_SCANLINE    Can do scanlines:"
       Data.l #PC_WIDE        : Data.s "PC_WIDE        Can do wide borders:"
       Data.l #PC_STYLED      : Data.s "PC_STYLED      Can do styled borders:"
       Data.l #PC_WIDESTYLED  : Data.s "PC_WIDESTYLED  Can do wide and styled borders:"
       Data.l #PC_INTERIORS   : Data.s "PC_INTERIORS   Can do interiors:"

    text_data:
       Data.l #TC_OP_CHARACTER  : Data.s "TC_OP_CHARACTER Can do character output precision:"
       Data.l #TC_OP_STROKE     : Data.s "TC_OP_STROKE    Can do stroke output precision:"
       Data.l #TC_CP_STROKE     : Data.s "TC_CP_STROKE    Can do stroke clip precision:"
       Data.l #TC_CR_90         : Data.s "TC_CP_90        Can do 90 degree character rotation:"
       Data.l #TC_CR_ANY        : Data.s "TC_CR_ANY       Can do any character rotation:"
       Data.l #TC_SF_X_YINDEP   : Data.s "TC_SF_X_YINDEP  Can do scaling independent of X and Y:"
       Data.l #TC_SA_DOUBLE     : Data.s "TC_SA_DOUBLE    Can do doubled character for scaling:"
       Data.l #TC_SA_INTEGER    : Data.s "TC_SA_INTEGER   Can do integer multiples for scaling:"
       Data.l #TC_SA_CONTIN     : Data.s "TC_SA_CONTIN    Can do any multiples for exact scaling:"
       Data.l #TC_EA_DOUBLE     : Data.s "TC_EA_DOUBLE    Can do double weight characters:"
       Data.l #TC_IA_ABLE       : Data.s "TC_IA_ABLE      Can do italicizing:"
       Data.l #TC_UA_ABLE       : Data.s "TC_UA_ABLE      Can do underlining:"
       Data.l #TC_SO_ABLE       : Data.s "TC_SO_ABLE      Can do strikeouts:"
       Data.l #TC_RA_ABLE       : Data.s "TC_RA_ABLE      Can do raster fonts:"
       Data.l #TC_VA_ABLE       : Data.s "TC_VA_ABLE      Can do vector fonts:"
EndDataSection
#CURVESDATALINES = 8
#LINESDATALINES = 7
#POLYDATALINES = 8
#TEXTDATALINES = 15
    Dim curves.BITS(#CURVESDATALINES-1)
    Dim lines.BITS(#LINESDATALINES-1)
    Dim poly.BITS(#POLYDATALINES-1)
    Dim text.BITS(#TEXTDATALINES-1)
    Define i

    Restore curves_data
    For i = 0 To #CURVESDATALINES-1
        Read.l curves(i)\imask
        Read.s curves(i)\desc
    Next i
    Restore lines_data
    For i = 0 To #LINESDATALINES-1
        Read.l lines(i)\imask
        Read.s lines(i)\desc
    Next i
    Restore poly_data
    For i = 0 To #POLYDATALINES-1
        Read.l poly(i)\imask
        Read.s poly(i)\desc
    Next i
    Restore text_data
    For i = 0 To #TEXTDATALINES-1
        Read.l text(i)\imask
        Read.s text(i)\desc
    Next i

Structure BIT_INFO
    index.i
    szTitle.s
    pbits.i
    iSize.i
EndStructure

Define *curv = curves()

DataSection
    bit_info_data:
       Data.i #CURVECAPS     : Data.s "CURVCAPS(Curve Capabilities)"         : Data.l #CURVESDATALINES
       Data.l #LINECAPS      : Data.s "LINECAPS(Line Capabilities)"          : Data.i #LINESDATALINES
       Data.l #POLYGONALCAPS : Data.s "POLYGONALCAPS(Polygonal Capabilities)": Data.i #POLYDATALINES
       Data.l #TEXTCAPS      : Data.s "TEXTCAPS(Text Capabilities)"          : Data.i #TEXTDATALINES
EndDataSection
    Dim bit_info.BIT_INFO(3)
    Restore bit_info_data
    For i = 0 To 3
        Read.i bit_info(i)\index
        Read.s bit_info(i)\szTitle
                ; array addresses we have To put in by hand
        Read.i bit_info(i)\iSize
    Next i
    bit_info(0)\pbits = @curves()
    bit_info(1)\pbits = @lines()
    bit_info(2)\pbits = @poly()
    bit_info(3)\pbits = @text()

Procedure do_bit_coded_caps(hdc, hdc_info, char_width, char_height, i_type)
    Shared curves(), lines(), poly(), text(), bit_info()
    Define *pbits.BITS = bit_info(i_type)\pbits
    Define i, dev_caps = GetDeviceCaps_(hdc_info, bit_info(i_type)\index)

    text_out(hdc, char_width, char_height, bit_info(i_type)\szTitle)

    For i = 0 To bit_info(i_type)\iSize-1
        If dev_caps & *pbits\iMask
            Define capabilityPresent.s = "Yes"
        Else
            capabilityPresent = "No"
        EndIf
    
        Define s_buffer.s = LSet(*pbits\desc,55) + " " + RSet(capabilityPresent,3)
        text_out(hdc, char_width,(i + 3) * char_height, s_buffer)

                
        *pbits + SizeOf(BITS)
    Next i
EndProcedure
