; print1.pb
; based on print1.c by Charles Petzold, in PW5E
;
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "print1", main_caption.s = "Print Program 1"
Global hinstance = GetModuleHandle_(#NULL)

IncludePath ""
XIncludeFile "print1.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Static client_width, client_height
    Define hdc, hmenu

    Select message
        Case #WM_SIZE
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_CREATE
            hmenu = GetSystemMenu_(hwin, #FALSE)
            AppendMenu_(hmenu, #MF_SEPARATOR, 0, #NULL)
            AppendMenu_(hmenu, #MF_STRING, 1, "&Print")
        Case #WM_SYSCOMMAND
            if wparam = 1   ; This is undocumented in msdn; the bottom 4 bits are
                            ; supposed to be for internal use only, yet this works
                            ; fine!
                If Not print_my_page(hwin)
                    MessageBox_(hwin, "Could not print page!", app_name, #MB_OK | #MB_ICONEXCLAMATION)
                EndIf
                ProcedureReturn 0
            EndIf
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            hdc = BeginPaint_(hwin, ps)

            page_gdi_calls(hdc, client_width, client_height)

            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect 

    ProcedureReturn 0 
EndProcedure 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam