; print1.pbi
;

Procedure page_gdi_calls(hdc_prn, page_width, page_height)
    Static text.s = "Hello, Printer!"

    Rectangle_(hdc_prn, 0, 0, page_width, page_height)

    line_to(hdc_prn, 0, 0, page_width, page_height)
    line_to(hdc_prn, page_width, 0, 0, page_height)

    SaveDC_(hdc_prn)

    SetMapMode_(hdc_prn, #MM_ISOTROPIC)
    SetWindowExtEx_(hdc_prn, 1000, 1000, #NULL)
    SetViewportExtEx_(hdc_prn, page_width / 2, -page_height / 2, #NULL)
    SetViewportOrgEx_(hdc_prn, page_width / 2,  page_height / 2, #NULL)

    Ellipse_(hdc_prn, -500, 500, 500, -500)

    SetTextAlign_(hdc_prn, #TA_BASELINE | #TA_CENTER)
    text_out(hdc_prn, 0, 0, text)

    RestoreDC_(hdc_prn, -1)
EndProcedure


Procedure print_my_page(hwnd)
    Define f_success = #TRUE
    Define page_width, page_height, hdc_prn = default_printer_dc()

    If hdc_prn = #NULL
        ProcedureReturn #FALSE
    EndIf

    page_width = GetDeviceCaps_(hdc_prn, #HORZRES)
    page_height = GetDeviceCaps_(hdc_prn, #VERTRES)

    Static di.DOCINFO
    di\cbSize = SizeOf(DOCINFO)
    di\lpszDocName = @"Print1: Printing"
    
    If StartDoc_(hdc_prn, di) > 0
        If StartPage_(hdc_prn) > 0
            page_gdi_calls(hdc_prn, page_width, page_height)

            If EndPage_(hdc_prn) > 0
                EndDoc_(hdc_prn)
            Else
                f_success = #FALSE
            EndIf
        EndIf
    Else
        f_success = #FALSE
    EndIf
    
    DeleteDC_(hdc_prn)
    ProcedureReturn f_success
EndProcedure

