; print2.pbi
;

Procedure page_gdi_calls(hdc_prn, page_width, page_height)
    Static text.s = "Hello, Printer!"

    Rectangle_(hdc_prn, 0, 0, page_width, page_height)

    line_to(hdc_prn, 0, 0, page_width, page_height)
    line_to(hdc_prn, page_width, 0, 0, page_height)

    SaveDC_(hdc_prn)

    SetMapMode_(hdc_prn, #MM_ISOTROPIC)
    SetWindowExtEx_(hdc_prn, 1000, 1000, #NULL)
    SetViewportExtEx_(hdc_prn, page_width / 2, -page_height / 2, #NULL)
    SetViewportOrgEx_(hdc_prn, page_width / 2,  page_height / 2, #NULL)

    Ellipse_(hdc_prn, -500, 500, 500, -500)

    SetTextAlign_(hdc_prn, #TA_BASELINE | #TA_CENTER)
    text_out(hdc_prn, 0, 0, text)

    RestoreDC_(hdc_prn, -1)
EndProcedure

Define f_user_abort, hprint_dlg

Procedure print_dlg_callback(hdlg, message, wparam, lparam)
    Shared f_user_abort, hprint_dlg
    Select message
        Case #WM_INITDIALOG
            SetWindowText_(hdlg, @app_name)
            EnableMenuItem_(GetSystemMenu_(hdlg, #FALSE), #SC_CLOSE, #MF_GRAYED)
            ProcedureReturn #TRUE
        Case #WM_COMMAND
            f_user_abort = #TRUE
            EnableWindow_(GetParent_(hdlg), #TRUE)
            DestroyWindow_(hdlg)
            hprint_dlg = #NULL
            ProcedureReturn #TRUE
    EndSelect
    ProcedureReturn #FALSE
EndProcedure

Procedure abort_proc(hdc_prn, code)
    Shared f_user_abort, hprint_dlg
    Define msg.MSG

    While Not f_user_abort And PeekMessage_(msg, #NULL, 0, 0, #PM_REMOVE)
        If Not hprint_dlg Or Not IsDialogMessage_(hprint_dlg, msg)
            TranslateMessage_(msg)
            DispatchMessage_(msg)
        EndIf
    Wend
    ProcedureReturn (Not f_user_abort)
EndProcedure

Procedure print_my_page(hwin)
    Shared f_user_abort, hprint_dlg
    Define f_success = #TRUE
    Define page_width, page_height, hdc_prn = default_printer_dc()

    If hdc_prn = #NULL
        ProcedureReturn #FALSE
    EndIf

    page_width = GetDeviceCaps_(hdc_prn, #HORZRES)
    page_height = GetDeviceCaps_(hdc_prn, #VERTRES)

    Static di.DOCINFO
    di\cbSize = SizeOf(DOCINFO)
    di\lpszDocName = @"Print3: Printing"

    EnableWindow_(hwin, #FALSE)

    f_user_abort = #FALSE
    hprint_dlg = CreateDialog_(hinstance, "PrintDlgBox", hwin, @print_dlg_callback())

    SetAbortProc_(hdc_prn, @abort_proc())

    If StartDoc_(hdc_prn, di) > 0
        If StartPage_(hdc_prn) > 0
            
            page_gdi_calls(hdc_prn, page_width, page_height)

            If EndPage_(hdc_prn) > 0
                EndDoc_(hdc_prn)
            Else
                f_success = #FALSE
            EndIf
        EndIf
    Else
        f_success = #FALSE
    EndIf

    If Not f_user_abort
        EnableWindow_(hwin, #TRUE)
        DestroyWindow_(hprint_dlg)
    EndIf
    DeleteDC_(hdc_prn)
    ProcedureReturn (f_success And Not f_user_abort)
EndProcedure
