;
; bitblt.pb
; based on bitblt.c by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "bitblt", main_caption.s = "BitBlt Demo"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static source_height, source_width
    
    Select message
        Case #WM_SIZE
            Static client_width, client_height
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            Define hdc_client = BeginPaint_(hwin, ps)
            Define hdc_window = GetWindowDC_(hwin)

            Define y=0
            While y <= client_height
                Define x=0
                While x <= client_width
                    BitBlt_(hdc_client, x, y, source_width, source_height, hdc_window, 0, 0, #SRCCOPY)
                    ; Step source_height
                    x + source_width
                Wend
                ; Step source_height
                y + source_height
            Wend
            ReleaseDC_(hwin, hdc_window)

            EndPaint_(hwin, ps)
        Case #WM_CREATE
            source_width = GetSystemMetrics_(#SM_CXSIZEFRAME) + GetSystemMetrics_(#SM_CXSMICON) + GetSystemMetrics_(#SM_CXSIZEFRAME)
            source_height = GetSystemMetrics_(#SM_CYSIZEFRAME) + GetSystemMetrics_(#SM_CYCAPTION)
        Case #WM_DESTROY
            PostQuitMessage_(0)
            ProcedureReturn 0
    EndSelect

    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(#NULL, #IDI_INFORMATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam