;
; bricks2.pb
; based on bricks2.C by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "bricks2", main_caption.s = "CreateBitmap Demo"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static bitmap.BITMAP
    Static Dim bits.b(7,1)
    Static hbitmap, client_width, client_height, source_width, source_height

    Select message
        Case #WM_CREATE
            bits(0,0) = $ff        ; create a small monochrome bitmap 'by hand' here
            bits(1,0) = $0c
            bits(2,0) = $0c
            bits(3,0) = $0c
            bits(4,0) = $ff
            bits(5,0) = $c0
            bits(6,0) = $c0
            bits(7,0) = $c0
            bitmap\bmType = 0
            bitmap\bmWidth = 8
            bitmap\bmHeight = 8
            bitmap\bmWidthBytes = 2
            bitmap\bmPlanes = 1
            bitmap\bmBitsPixel = 1
            bitmap\bmBits = @bits()
            
            hbitmap = CreateBitmapIndirect_(bitmap)
            source_width = bitmap\bmWidth
            source_height = bitmap\bmHeight

        Case #WM_SIZE
            client_width = LOWORD(lParam)
            client_height = HIWORD(lParam)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            Define hdc = BeginPaint_(hwin, ps)

            Define hdc_mem = CreateCompatibleDC_(hdc)
            SelectObject_(hdc_mem, hbitmap)

            Define x, y
            For y = 0 to client_height-1
                For x = 0 To client_width - 1
                    BitBlt_(hdc, x, y, source_width, source_height, hdc_mem, 0, 0, #SRCCOPY)
                    x + source_width - 1
                Next x
                y + source_height - 1
            Next y
            DeleteDC_(hdc_mem)

            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            DeleteObject_(hbitmap)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam