;
; hellobit.pb
; based on hellobit.C by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

IncludePath ""
XIncludeFile "hellobit.pbi"

Global app_name.s = "hellobit", main_caption.s = "HelloBit"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static hbitmap, hdc_mem, bitmap_width, bitmap_height, client_width, client_height, idm_size = #IDM_BIG
    Static text.s = " Hello, world!"

    Select message
        Case #WM_SIZE
            client_width = LOWORD(lParam)
            client_height = HIWORD(lParam)
        Case #WM_COMMAND
            Define hMenu = GetMenu_(hwin)
    
            Select (LOWORD(wParam))
                Case #IDM_BIG, #IDM_SMALL
                    CheckMenuItem_(hMenu, idm_size, #MF_UNCHECKED)
                    idm_size = LOWORD(wParam)
                    CheckMenuItem_(hMenu, idm_size, #MF_CHECKED)
                    InvalidateRect_(hwin, #NULL, #TRUE)
            EndSelect 
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            Define hdc = BeginPaint_(hwin, ps)

            Select (idm_size)
                Case #IDM_BIG
                    StretchBlt_(hdc, 0, 0, client_width, client_height, hdc_mem, 0, 0, bitmap_width, bitmap_height, #SRCCOPY)
                Case #IDM_SMALL
                    Define x,y
                    For y = 0 To client_height-1
                        For x = 0 To client_width - 1
                            BitBlt_(hdc, x, y, bitmap_width, bitmap_height, hdc_mem, 0, 0, #SRCCOPY)
                            x + bitmap_width - 1
                        Next x
                        y + bitmap_height - 1
                    Next y
            EndSelect 

            EndPaint_(hwin, ps)
        Case #WM_CREATE
            hdc = GetDC_(hwin)
            hdc_mem  = CreateCompatibleDC_(hdc)
    
            Define size.SIZE
            GetTextExtentPoint32_(hdc, @text, lstrlen_(@text), size)
            bitmap_width = size\cx
            bitmap_height = size\cy
            hbitmap = CreateCompatibleBitmap_(hdc, bitmap_width, bitmap_height)
    
            ReleaseDC_(hwin, hdc)
    
            SelectObject_(hdc_mem, hbitmap)
            text_out(hdc_mem, 0, 0, text)

        Case #WM_DESTROY
            DeleteDC_(hdc_mem)
            DeleteObject_(hbitmap)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
