;
; grafmenu.pb
; based on grafmenu.C by Charles Petzold, in PW5E
;      NOTE: I had to change the AddHelpToSys() so that it added the
;      bitmap menu item in a new column; the original,
;      which presumably worked under Windows 98, caused a problem
;      under XP (all the other menu times got squashed to the right).
;      I have not found a way yet to duplicate Petzold's original
;      intention; even Petzold's code has the same problem if you
;      run the compiled form.
;      If you want to see the problem, take out the MF_MENUBARBREAK flag
;      and run the program. 
IncludePath "..\"
XIncludeFile "petzold.pbi"

IncludePath ""
XIncludeFile "grafmenu.pbi"

Global app_name.s = "grafmenu", main_caption.s = "Bitmap Menu Demonstration"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Define hMenu, id
    Static id_current_font = #IDM_FONT_COUR

    Select message
        Case #WM_CREATE
            AddHelpToSys(hinstance, hwin)
            hMenu = CreateMyMenu(hinstance)
            SetMenu_(hwin, hMenu)
            CheckMenuItem_(hMenu, id_current_font, #MF_CHECKED)
        Case #WM_SYSCOMMAND
            id = LOWORD(wParam) 
            Select id
                Case #IDM_HELP
                    MessageBox_(hwin, "Help not yet implemented!", app_name, #MB_OK | #MB_ICONEXCLAMATION)
                    ProcedureReturn 0
                Default 
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndSelect 
        Case #WM_COMMAND
            id = LOWORD(wParam) 
            Select id
                Case #IDM_FILE_NEW, #IDM_FILE_OPEN, #IDM_FILE_SAVE, #IDM_FILE_SAVE_AS, #IDM_EDIT_UNDO, #IDM_EDIT_CUT, #IDM_EDIT_COPY, #IDM_EDIT_PASTE, #IDM_EDIT_CLEAR
                    MessageBeep_(0)
                Case #IDM_FONT_COUR, #IDM_FONT_ARIAL, #IDM_FONT_TIMES
                    hMenu = GetMenu_(hwin)
                    CheckMenuItem_(hMenu, id_current_font, #MF_UNCHECKED)
                    id_current_font = LOWORD(wParam)
                    CheckMenuItem_(hMenu, id_current_font, #MF_CHECKED)
                Default 
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndSelect 
            ProcedureReturn 0
        Case #WM_DESTROY
            DeleteAllBitmaps(hwin)
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
