;
; dibheads.pb
; based on dibheads.c by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

IncludePath ""
XIncludeFile "dibheads.pbi"

Global app_name.s = "dibheads", main_caption.s = "DIB Headers"
Global hinstance = GetModuleHandle_(#NULL)


Procedure main_callback(hwin, message, wparam, lparam)
    Static hedit, ofn.OPENFILENAME, file_name.s{#MAX_PATH}, title_name.s{#MAX_PATH}
    DataSection
        ; PureBasic's string handling puts in the null terminators we need
        custom_file_filters: 
        Data.s "Bitmap Files(*\BMP)" 
        Data.s "*.bmp"
        Data.s "All Files(*.*)"
        Data.s "*.*"
        Data.c 0      ; Filter list should end with an extra null terminator.
                      ; Note the data type: PureBasic will make it byte or word
                      ; depending on compilation mode.
    EndDataSection

    Select message
        Case #WM_CREATE
            hedit = CreateWindow_(@WC_EDIT,#NULL,#WS_CHILD | #WS_VISIBLE | #WS_BORDER | #WS_VSCROLL | #WS_HSCROLL | #ES_MULTILINE | #ES_AUTOVSCROLL | #ES_READONLY,0,0,0,0,hwin,1,hinstance,#NULL)
    
            With ofn
                \lStructSize      = SizeOf(OPENFILENAME)
                \hwndOwner        = hwin
                \lpstrFilter      = ?custom_file_filters
                \lpstrFile        = @file_name
                \nMaxFile        = #MAX_PATH
                \lpstrFileTitle    = @title_name
                \nMaxFileTitle    = #MAX_PATH
                \lpstrDefExt      = @"bmp"
            EndWith 
        Case #WM_SIZE
            Static client_width, client_height
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
            MoveWindow_(hedit, 0, 0, client_width, client_height, #TRUE)
        Case #WM_COMMAND
            Select (LOWORD(wParam))
                Case #IDM_FILE_OPEN
                    If GetOpenFileName_(ofn)
                        DisplayDibHeaders(hedit, file_name)
                    EndIf 
                Default 
                    ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
            EndSelect 
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
            \lpszMenuName = @app_name
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define haccel = LoadAccelerators_(hInstance, app_name)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        If Not TranslateAccelerator_(hwin, haccel, msg)
            TranslateMessage_(msg)
            DispatchMessage_(msg)
         EndIf 
    Wend

End msg\wparam
