;
; apollo11.pb
; based on apollo11.c by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

IncludePath ""
XIncludeFile "dibfile.pbi"


Global app_name.s = "apollo11", main_caption.s = "Apollo 11"
Global hinstance = GetModuleHandle_(#NULL)

Procedure main_callback(hwin, message, wparam, lparam)
    Static Dim *pbmfh.BITMAPFILEHEADER(1), Dim *pbmi.BITMAPINFO(1)
    Static Dim *pBits(1), Dim dib_width(1), Dim dib_height(1)
    Static client_width, client_height 

    Select message
        Case #WM_CREATE
            *pbmfh(0) = DibLoadImage("Apollo11.bmp")
            *pbmfh(1) = DibLoadImage("ApolloTD.bmp")
    
            If *pbmfh(0) = #NULL Or *pbmfh(1) = #NULL
                MessageBox_(hwin, "Cannot load DIB file", app_name, #MB_OK)
            Else 
                ; Get pointers to the info structure & the bits
                *pbmi(0) = *pbmfh(0) + SizeOf(BITMAPFILEHEADER)
                *pbmi(1) = *pbmfh(1) + SizeOf(BITMAPFILEHEADER)
    
                *pBits(0) = *pbmfh(0) + *pbmfh(0)\bfOffBits
                *pBits(1) = *pbmfh(1) + *pbmfh(1)\bfOffBits
        
                ; Get the DIB width and height(assume BITMAPINFOHEADER)
                ; Note that dib_height is the absolute value of the header valueNot Not Not 
                dib_width(0) = *pbmi(0)\bmiHeader\biWidth
                dib_width(1) = *pbmi(1)\bmiHeader\biWidth
        
                dib_height(0) = absi(*pbmi(0)\bmiHeader\biHeight)
                dib_height(1) = absi(*pbmi(1)\bmiHeader\biHeight)
            EndIf 
        Case #WM_SIZE
            client_width = LOWORD(lParam)
            client_height = HIWORD(lParam)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT, hdc = BeginPaint_(hwin, ps)
    
            ; Bottom-up DIB full size
            SetDIBitsToDevice_(hdc, 0, client_height / 4, dib_width(0), dib_height(0), 0, 0, 0, dib_height(0), *pBits(0), *pbmi(0), #DIB_RGB_COLORS)
    
            ; Bottom-up DIB partial
            SetDIBitsToDevice_(hdc, 240, client_height / 4,  80, 166, 80, 60, 0, dib_height(0), *pBits(0), *pbmi(0), #DIB_RGB_COLORS)
    
            ; Top-down DIB full size
            SetDIBitsToDevice_(hdc, 340, client_height / 4, dib_width(0), dib_height(0), 0, 0, 0, dib_height(0), *pBits(0), *pbmi(0), #DIB_RGB_COLORS)
    
            ; Top-down DIB partial
            SetDIBitsToDevice_(hdc, 580, client_height / 4, 80, 166, 80, 60, 0, dib_height(1), *pBits(1), *pbmi(1), #DIB_RGB_COLORS)
    
            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            If *pbmfh(0)
                FreeMemory(*pbmfh(0))
            EndIf 
            
            If *pbmfh(1)
                FreeMemory(*pbmfh(1))
            EndIf 
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)


    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
