#IDM_FILE_OPEN = 40001

Procedure CreateBitmapObjectFromDibFile(hdc, file_name.s)
    Define *bmfh.BITMAPFILEHEADER, success, file_size.q, bytes_read

    ; Open the file: read access, prohibit write access
    Define hfile = CreateFile_(file_name, #GENERIC_READ, #FILE_SHARE_READ, #NULL, #OPEN_EXISTING, #FILE_FLAG_SEQUENTIAL_SCAN, #NULL)

    If hfile = #INVALID_HANDLE_VALUE
        ProcedureReturn #NULL
    EndIf 

    ; Read in the whole file
    file_size = FileSize(file_name)

    If file_size > $7FFFFFFF  
        CloseHandle_(hfile)
        ProcedureReturn #NULL
    EndIf 

    *bmfh = AllocateMemory(file_size)

    If Not *bmfh
        CloseHandle_(hfile)
        ProcedureReturn #NULL
    EndIf 

    success = ReadFile_(hfile, *bmfh, file_size, @bytes_read, #NULL)
    CloseHandle_(hfile)

    ; Verify the file
    Define bf_type.s = PeekS( @*bmfh\bfType, 2, #PB_Ascii )
    If (Not success) Or (bytes_read <> file_size) Or (bf_type <> "BM") Or (*bmfh\bfSize <> file_size)
        FreeMemory(*bmfh)
        ProcedureReturn #NULL
    EndIf 

    ; Create the DDB 
    Define hbitmap = CreateDIBitmap_(hdc, *bmfh + SizeOf(BITMAPFILEHEADER), #CBM_INIT, *bmfh + *bmfh\bfOffBits, *bmfh + SizeOf(BITMAPFILEHEADER), #DIB_RGB_COLORS)
    FreeMemory(*bmfh)

    ProcedureReturn hbitmap
EndProcedure 

