
Procedure CreateDibSectionFromDibFile(file_name.s)
    ; Open the file: read access, prohibit write access
    Define hfile = CreateFile_(file_name, #GENERIC_READ, #FILE_SHARE_READ, #NULL, #OPEN_EXISTING, 0, #NULL)

    If hfile = #INVALID_HANDLE_VALUE
        ProcedureReturn #NULL
    EndIf 

    ; Read in the BITMAPFILEHEADER    
    Define bmfh.BITMAPFILEHEADER, bytes_read
    Define success = ReadFile_(hfile, bmfh, SizeOf(BITMAPFILEHEADER), @bytes_read, #NULL)

    ; Verify the file
    Define bf_type.s = PeekS( @bmfh\bfType, 2, #PB_Ascii )
    If (Not success) Or (bytes_read <> SizeOf(BITMAPFILEHEADER)) Or (bf_type <> "BM")
        CloseHandle_(hfile)
        ProcedureReturn #NULL
    EndIf 

    ; Allocate memory for the BITMAPINFO structure & read it in
    Define bmp_info_byte_count = bmfh\bfOffBits - SizeOf(BITMAPFILEHEADER)

    Define *pbmi.BITMAPINFO = AllocateMemory(bmp_info_byte_count)
    If Not *pbmi
        CloseHandle_(hfile)
        ProcedureReturn #NULL
    EndIf 
    
    success = ReadFile_(hfile, *pbmi, bmp_info_byte_count, @bytes_read, #NULL)

    If (Not success) Or (bytes_read <> bmp_info_byte_count)
        FreeMemory(*pbmi)
        CloseHandle_(hfile)
        ProcedureReturn #NULL
    EndIf 
    
    ; Create the DIB Section
    Define *pbits
    Define hbitmap = CreateDIBSection_(#NULL, *pbmi, #DIB_RGB_COLORS, @*pbits, #NULL, 0)
    
    ; Read in the bitmap bits
    If hbitmap
        ReadFile_(hfile, *pbits, bmfh\bfSize - bmfh\bfOffBits, @bytes_read, #NULL)
    EndIf 
    
    FreeMemory(*pbmi)
    CloseHandle_(hfile)
    
    ProcedureReturn hbitmap
EndProcedure 