;
; grays1.pb
; based on grays1.c by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "grays1", main_caption.s = "Shades of Gray #1"
Global hinstance = GetModuleHandle_(#Null)

Procedure main_callback(hwin, message, wparam, lparam)

    Select message
        Case #WM_SIZE
            Static client_width, client_height
            client_width = LOWORD(lparam)
            client_height = HIWORD(lparam)
        Case #WM_PAINT
            Define ps.PAINTSTRUCT
            Define hdc = BeginPaint_(hwin, ps)

            ; Draw the fountain of grays
            Define i, rect.RECT, hbrush
            For i = 0 To 64
                rect\left   = i * client_width / 65
                rect\top    = 0
                rect\right  = (i + 1) * client_width / 65
                rect\bottom = client_height
    
                hbrush = CreateSolidBrush_(RGB(min(255, 4 * i), min(255, 4 * i), min(255, 4 * i)))
    
                FillRect_(hdc, rect, hbrush)
                DeleteObject_(hbrush)
            Next i

            EndPaint_(hwin, ps)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#Null, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf
        
    Define hwin = CreateWindowEx_(#Null,app_name,main_caption,#WS_OVERLAPPEDWINDOW | #WS_CLIPCHILDREN,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#Null, #Null,hinstance,#Null)
        If Not hwin
            MessageBox_(#Null, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

;    Define haccel = LoadAccelerators_(hInstance, szAppName)

    Define msg.MSG
    While GetMessage_(msg, #Null, 0, 0) > 0
;        If Not TranslateAccelerator_(hwin, haccel, msg)
        TranslateMessage_(msg)
        DispatchMessage_(msg)
;        EndIf 
    Wend

End msg\wparam

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 4
; Folding = -
; EnableXP