;
; syspal1.pb
; based on syspal1.c by Charles Petzold, in PW5E
IncludePath "..\"
XIncludeFile "petzold.pbi"

Global app_name.s = "syspal1", main_caption.s = "System Palette #1"
Global hinstance = GetModuleHandle_(#NULL)

IncludePath ""
XIncludeFile "syspal1.pbi"

Procedure main_callback(hwin, message, wparam, lparam)
    Define hdc, ps.PAINTSTRUCT
    Dim pe.PALETTEENTRY(255)
    Static size_char.SIZE, client_width, client_height

    Select message
        Case #WM_CREATE
            If Not CheckDisplay(hwin)
                ProcedureReturn -1
            EndIf
            hdc = GetDC_(hwin)
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
            GetTextExtentPoint32_(hdc, @"FF-FF-FF", 10, size_char)
            ReleaseDC_(hwin, hdc)
        Case #WM_DISPLAYCHANGE
            If (Not CheckDisplay(hwin))
                DestroyWindow_(hwin)
            EndIf 
        Case #WM_SIZE
            client_width = LOWORD(lParam)
            client_height = HIWORD(lParam)
        Case #WM_PAINT
            hdc = BeginPaint_(hwin, ps)
    
            SelectObject_(hdc, GetStockObject_(#SYSTEM_FIXED_FONT))
    
            GetSystemPaletteEntries_(hdc, 0, 256, @pe(0))
    
            Define i,x=0,y=0
            For i = 0 To 255
                ; purebasic's lack of an unsigned type can require some odd
                ; workarounds sometimes...
                Define r,g,b
                r = $FF & pe(i)\peRed
                g = $FF & pe(i)\peGreen
                b = $FF & pe(i)\peBlue
                text_out(hdc, x, y, RSet(Hex(r),2,"0") + "-" + RSet(Hex(g),2,"0") + "-" + RSet(Hex(b),2,"0"))
    
                x + size_char\cx
                If (x + size_char\cx > client_width)
                    x = 0
            
                    y + size_char\cy
                    If  y > client_height 
                        break
                    EndIf 
                EndIf 
            Next i
            EndPaint_(hwin, ps)
        Case #WM_PALETTECHANGED
            InvalidateRect_(hwin, #NULL, #FALSE)
        Case #WM_DESTROY
            PostQuitMessage_(0)
        Default
            ProcedureReturn DefWindowProc_(hwin, message, wparam, lparam)
    EndSelect

    ProcedureReturn 0
EndProcedure
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MAIN PROGRAM CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    Define main_class.WNDCLASS
        With main_class
            \lpfnWndProc = @main_callback()
            \hinstance = hinstance
            \lpszClassName = @app_name
            \style = #CS_HREDRAW | #CS_VREDRAW
            \hicon = LoadIcon_(0, #IDI_APPLICATION)
            \hcursor = LoadCursor_(0, #IDC_ARROW)
            \hbrBackground = #COLOR_WINDOW + 1
        EndWith
        If Not RegisterClass_(main_class)
            MessageBox_(#NULL, "Cannot register window class!", app_name, #MB_ICONERROR)
            End 0
        EndIf


    Define hwin = CreateWindowEx_(#NULL,app_name,main_caption,#WS_OVERLAPPEDWINDOW,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#CW_USEDEFAULT,#NULL, #NULL,hinstance,#NULL)
        If Not hwin
            MessageBox_(#NULL, "Unable to create main window.", app_name, #MB_ICONERROR)
            End 0
        EndIf

        ShowWindow_(hwin, #SW_SHOW)
        UpdateWindow_(hwin)

    Define msg.MSG
    While GetMessage_(msg, #NULL, 0, 0) > 0
        TranslateMessage_(msg)
        DispatchMessage_(msg)
    Wend

End msg\wparam
